package daikon.inv.quaternary;

import daikon.PptSlice;
import daikon.inv.Invariant;
import daikon.inv.InvariantStatus;

/**
 * Exists simply to provide a more intelligent resusurrect_done method.
 **/
public abstract class QuaternaryInvariant
  extends Invariant
{
  // We are Serializable, so we specify a version to allow changes to
  // method signatures without breaking serialization.  If you add or
  // remove fields, you should change this number to the current date.
  static final long serialVersionUID = 20121008L;

  protected QuaternaryInvariant(PptSlice ppt) {
    super(ppt);
  }

  protected QuaternaryInvariant() {
    super();
  }

  // Check if swap occurred and call one of the other methods
  protected Invariant resurrect_done(int[] permutation) {
    assert permutation.length == 4;
    // assert ArraysMDE.fn_is_permutation(permutation);
    throw new Error("to implement");
  }

  public abstract InvariantStatus add(Object val1, Object val2, Object val3, Object val4, int mod_index, int count);

  public abstract InvariantStatus check(Object val1, Object val2, Object val3, Object val4, int mod_index, int count);


}
