# $ANTLR 3.5 JMLformulas.g 2013-08-30 17:18:07

import sys
from antlr3 import *
from antlr3.compat import set, frozenset

        
import sys
import traceback

from JMLformulasLexer import JMLformulasLexer
from JML_ast import *

def primaryCombine (target, idlist, suffix):
   if suffix is None:
      res = AttributeCall()
      res.target = target
      res.call = idlist
   elif suffix[0] == '(':
      res = MethodCall()
      res.target = target
      res.call = idlist
      ss = suffix[1]
      res.args = ss if type(ss) is list or type(ss) is tuple else [ss] # just a patch
   elif suffix[0] == '[':
      res = ArrayReference()
      res.target = target
      res.call = idlist
      ss = suffix[1]
      res.args = ss if type(ss) is list or type(ss) is tuple else [ss] # just a patch
   return res

def selsCombine (target, sels):
   if len(sels) == 0:
      return target
   else:
      ss = sels[0]
      if len(ss) == 1:
         first = primaryCombine(target, [], ('[', ss[0]))
      elif ss[1] is None:
         first = primaryCombine(target, [ss[0]], None)
      else:
         first = primaryCombine(target, [ss[0]], ('(', ss[1]))
      if len(sels) == 1:
         return first
      else:
         return selsCombine(first, sels[1:])



# for convenience in actions
HIDDEN = BaseRecognizer.HIDDEN

# token types
EOF=-1
T__118=118
T__119=119
T__120=120
T__121=121
T__122=122
T__123=123
T__124=124
T__125=125
T__126=126
T__127=127
T__128=128
ABSTRACT=4
AMP=5
AMPAMP=6
AMPEQ=7
ASSERT=8
BANG=9
BANGEQ=10
BAR=11
BARBAR=12
BAREQ=13
BOOLEAN=14
BREAK=15
BYTE=16
CARET=17
CARETEQ=18
CASE=19
CATCH=20
CHAR=21
CHARLITERAL=22
CLASS=23
COLON=24
COMMA=25
CONST=26
CONTINUE=27
DEFAULT=28
DO=29
DOT=30
DOUBLE=31
DOUBLELITERAL=32
DoubleSuffix=33
ELLIPSIS=34
ELSE=35
ENUM=36
EQ=37
EQEQ=38
EXTENDS=39
EscapeSequence=40
Exponent=41
FALSE=42
FINAL=43
FINALLY=44
FLOAT=45
FLOATLITERAL=46
FOR=47
FloatSuffix=48
GOTO=49
GT=50
HexDigit=51
HexPrefix=52
IDENTIFIER=53
IF=54
IMPLEMENTS=55
IMPORT=56
INSTANCEOF=57
INT=58
INTERFACE=59
INTLITERAL=60
IdentifierPart=61
IdentifierStart=62
IntegerNumber=63
LBRACE=64
LBRACKET=65
LINE_COMMENT=66
LONG=67
LONGLITERAL=68
LPAREN=69
LT=70
LongSuffix=71
MONKEYS_AT=72
NATIVE=73
NEW=74
NULL=75
NonIntegerNumber=76
PACKAGE=77
PERCENT=78
PERCENTEQ=79
PLUS=80
PLUSEQ=81
PLUSPLUS=82
PRIVATE=83
PROTECTED=84
PUBLIC=85
QUES=86
RBRACE=87
RBRACKET=88
RETURN=89
RPAREN=90
SEMI=91
SHORT=92
SLASH=93
SLASHEQ=94
STAR=95
STAREQ=96
STATIC=97
STRICTFP=98
STRINGLITERAL=99
SUB=100
SUBEQ=101
SUBSUB=102
SUPER=103
SWITCH=104
SYNCHRONIZED=105
SurrogateIdentifer=106
THIS=107
THROW=108
THROWS=109
TILDE=110
TRANSIENT=111
TRUE=112
TRY=113
VOID=114
VOLATILE=115
WHILE=116
WS=117

# token names
tokenNames = [
    "<invalid>", "<EOR>", "<DOWN>", "<UP>",
    "ABSTRACT", "AMP", "AMPAMP", "AMPEQ", "ASSERT", "BANG", "BANGEQ", "BAR", 
    "BARBAR", "BAREQ", "BOOLEAN", "BREAK", "BYTE", "CARET", "CARETEQ", "CASE", 
    "CATCH", "CHAR", "CHARLITERAL", "CLASS", "COLON", "COMMA", "CONST", 
    "CONTINUE", "DEFAULT", "DO", "DOT", "DOUBLE", "DOUBLELITERAL", "DoubleSuffix", 
    "ELLIPSIS", "ELSE", "ENUM", "EQ", "EQEQ", "EXTENDS", "EscapeSequence", 
    "Exponent", "FALSE", "FINAL", "FINALLY", "FLOAT", "FLOATLITERAL", "FOR", 
    "FloatSuffix", "GOTO", "GT", "HexDigit", "HexPrefix", "IDENTIFIER", 
    "IF", "IMPLEMENTS", "IMPORT", "INSTANCEOF", "INT", "INTERFACE", "INTLITERAL", 
    "IdentifierPart", "IdentifierStart", "IntegerNumber", "LBRACE", "LBRACKET", 
    "LINE_COMMENT", "LONG", "LONGLITERAL", "LPAREN", "LT", "LongSuffix", 
    "MONKEYS_AT", "NATIVE", "NEW", "NULL", "NonIntegerNumber", "PACKAGE", 
    "PERCENT", "PERCENTEQ", "PLUS", "PLUSEQ", "PLUSPLUS", "PRIVATE", "PROTECTED", 
    "PUBLIC", "QUES", "RBRACE", "RBRACKET", "RETURN", "RPAREN", "SEMI", 
    "SHORT", "SLASH", "SLASHEQ", "STAR", "STAREQ", "STATIC", "STRICTFP", 
    "STRINGLITERAL", "SUB", "SUBEQ", "SUBSUB", "SUPER", "SWITCH", "SYNCHRONIZED", 
    "SurrogateIdentifer", "THIS", "THROW", "THROWS", "TILDE", "TRANSIENT", 
    "TRUE", "TRY", "VOID", "VOLATILE", "WHILE", "WS", "'<=!=>'", "'<='", 
    "'<=='", "'<==>'", "'==>'", "'>='", "'\\\\exists'", "'\\\\forall'", 
    "'\\\\old'", "'\\\\pre'", "'\\\\result'"
]




class JMLformulasParser(Parser):
    grammarFileName = "JMLformulas.g"
    api_version = 1
    tokenNames = tokenNames

    def __init__(self, input, state=None, *args, **kwargs):
        if state is None:
            state = RecognizerSharedState()

        super(JMLformulasParser, self).__init__(input, state, *args, **kwargs)

        self._state.ruleMemo = {}




        self.delegates = []






    # $ANTLR start "jml_formula"
    # JMLformulas.g:110:1: jml_formula returns [result] : expression ';' ;
    def jml_formula(self, ):
        result = None

        jml_formula_StartIndex = self.input.index()

        expression1 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 1):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:111:5: ( expression ';' )
                # JMLformulas.g:111:9: expression ';'
                pass 
                self._state.following.append(self.FOLLOW_expression_in_jml_formula85)
                expression1 = self.expression()

                self._state.following.pop()

                self.match(self.input, SEMI, self.FOLLOW_SEMI_in_jml_formula87)

                if self._state.backtracking == 0:
                    pass
                    result =  expression1 






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 1, jml_formula_StartIndex, success)


            pass
        return result

    # $ANTLR end "jml_formula"



    # $ANTLR start "expression"
    # JMLformulas.g:123:1: expression returns [result] : conditionalExpression ;
    def expression(self, ):
        result = None

        expression_StartIndex = self.input.index()

        conditionalExpression2 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 2):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:124:5: ( conditionalExpression )
                # JMLformulas.g:124:9: conditionalExpression
                pass 
                self._state.following.append(self.FOLLOW_conditionalExpression_in_expression126)
                conditionalExpression2 = self.conditionalExpression()

                self._state.following.pop()

                if self._state.backtracking == 0:
                    pass
                    result =  conditionalExpression2 






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 2, expression_StartIndex, success)


            pass
        return result

    # $ANTLR end "expression"



    # $ANTLR start "conditionalExpression"
    # JMLformulas.g:128:1: conditionalExpression returns [result] : cnd= equivalenceExpression ( '?' th= expression ':' el= conditionalExpression )? ;
    def conditionalExpression(self, ):
        result = None

        conditionalExpression_StartIndex = self.input.index()

        cnd = None
        th = None
        el = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 3):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:129:5: (cnd= equivalenceExpression ( '?' th= expression ':' el= conditionalExpression )? )
                # JMLformulas.g:129:9: cnd= equivalenceExpression ( '?' th= expression ':' el= conditionalExpression )?
                pass 
                self._state.following.append(self.FOLLOW_equivalenceExpression_in_conditionalExpression161)
                cnd = self.equivalenceExpression()

                self._state.following.pop()

                if self._state.backtracking == 0:
                    pass
                    l_ex = False; 



                # JMLformulas.g:131:9: ( '?' th= expression ':' el= conditionalExpression )?
                alt1 = 2
                LA1_0 = self.input.LA(1)

                if (LA1_0 == QUES) :
                    alt1 = 1
                if alt1 == 1:
                    # JMLformulas.g:131:10: '?' th= expression ':' el= conditionalExpression
                    pass 
                    self.match(self.input, QUES, self.FOLLOW_QUES_in_conditionalExpression182)

                    self._state.following.append(self.FOLLOW_expression_in_conditionalExpression186)
                    th = self.expression()

                    self._state.following.pop()

                    self.match(self.input, COLON, self.FOLLOW_COLON_in_conditionalExpression188)

                    self._state.following.append(self.FOLLOW_conditionalExpression_in_conditionalExpression192)
                    el = self.conditionalExpression()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                        l_ex = True; 






                if self._state.backtracking == 0:
                    pass
                             
                    if not l_ex:
                       result =  cnd
                    else:
                       result =  ConditionalExpression() 
                       result.condition = cnd;  
                       result.then_exp = th; 
                       result.else_exp = el; 







                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 3, conditionalExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "conditionalExpression"



    # $ANTLR start "equivalenceExpression"
    # JMLformulas.g:145:1: equivalenceExpression returns [result] : l= impliesExpression ( equivalenceOp r= impliesExpression )? ;
    def equivalenceExpression(self, ):
        result = None

        equivalenceExpression_StartIndex = self.input.index()

        l = None
        r = None
        equivalenceOp3 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 4):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:146:5: (l= impliesExpression ( equivalenceOp r= impliesExpression )? )
                # JMLformulas.g:146:9: l= impliesExpression ( equivalenceOp r= impliesExpression )?
                pass 
                self._state.following.append(self.FOLLOW_impliesExpression_in_equivalenceExpression252)
                l = self.impliesExpression()

                self._state.following.pop()

                if self._state.backtracking == 0:
                    pass
                    l_ex = False; 



                # JMLformulas.g:148:9: ( equivalenceOp r= impliesExpression )?
                alt2 = 2
                LA2_0 = self.input.LA(1)

                if (LA2_0 == 118 or LA2_0 == 121) :
                    alt2 = 1
                if alt2 == 1:
                    # JMLformulas.g:148:10: equivalenceOp r= impliesExpression
                    pass 
                    self._state.following.append(self.FOLLOW_equivalenceOp_in_equivalenceExpression273)
                    equivalenceOp3 = self.equivalenceOp()

                    self._state.following.pop()

                    self._state.following.append(self.FOLLOW_impliesExpression_in_equivalenceExpression277)
                    r = self.impliesExpression()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                        l_ex = True; 






                if self._state.backtracking == 0:
                    pass
                            
                    if not l_ex:
                       result =  l
                    else:
                       equivalenceOp3.left = l;
                       equivalenceOp3.right = r;
                       result = equivalenceOp3







                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 4, equivalenceExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "equivalenceExpression"



    # $ANTLR start "equivalenceOp"
    # JMLformulas.g:161:1: equivalenceOp returns [result] : ( '<==>' | '<=!=>' );
    def equivalenceOp(self, ):
        result = None

        equivalenceOp_StartIndex = self.input.index()

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 5):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:162:5: ( '<==>' | '<=!=>' )
                alt3 = 2
                LA3_0 = self.input.LA(1)

                if (LA3_0 == 121) :
                    alt3 = 1
                elif (LA3_0 == 118) :
                    alt3 = 2
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed


                    nvae = NoViableAltException("", 3, 0, self.input)

                    raise nvae


                if alt3 == 1:
                    # JMLformulas.g:162:9: '<==>'
                    pass 
                    self.match(self.input, 121, self.FOLLOW_121_in_equivalenceOp335)

                    if self._state.backtracking == 0:
                        pass
                        result =  IffExpression() 




                elif alt3 == 2:
                    # JMLformulas.g:164:9: '<=!=>'
                    pass 
                    self.match(self.input, 118, self.FOLLOW_118_in_equivalenceOp355)

                    if self._state.backtracking == 0:
                        pass
                        result =  NIffExpression() 





                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 5, equivalenceOp_StartIndex, success)


            pass
        return result

    # $ANTLR end "equivalenceOp"



    # $ANTLR start "impliesExpression"
    # JMLformulas.g:168:1: impliesExpression returns [result] : (ant= conditionalOrExpression ( '==>' ie= impliesNonBackwardExpression )* | conditionalOrExpression ( '<==' conditionalOrExpression )+ );
    def impliesExpression(self, ):
        result = None

        impliesExpression_StartIndex = self.input.index()

        ant = None
        ie = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 6):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:169:5: (ant= conditionalOrExpression ( '==>' ie= impliesNonBackwardExpression )* | conditionalOrExpression ( '<==' conditionalOrExpression )+ )
                alt6 = 2
                LA6 = self.input.LA(1)
                if LA6 == PLUS:
                    LA6_1 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 1, self.input)

                        raise nvae


                elif LA6 == SUB:
                    LA6_2 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 2, self.input)

                        raise nvae


                elif LA6 == TILDE:
                    LA6_3 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 3, self.input)

                        raise nvae


                elif LA6 == BANG:
                    LA6_4 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 4, self.input)

                        raise nvae


                elif LA6 == LPAREN:
                    LA6_5 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 5, self.input)

                        raise nvae


                elif LA6 == THIS:
                    LA6_6 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 6, self.input)

                        raise nvae


                elif LA6 == IDENTIFIER:
                    LA6_7 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 7, self.input)

                        raise nvae


                elif LA6 == SUPER:
                    LA6_8 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 8, self.input)

                        raise nvae


                elif LA6 == INTLITERAL:
                    LA6_9 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 9, self.input)

                        raise nvae


                elif LA6 == LONGLITERAL:
                    LA6_10 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 10, self.input)

                        raise nvae


                elif LA6 == FLOATLITERAL:
                    LA6_11 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 11, self.input)

                        raise nvae


                elif LA6 == DOUBLELITERAL:
                    LA6_12 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 12, self.input)

                        raise nvae


                elif LA6 == CHARLITERAL:
                    LA6_13 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 13, self.input)

                        raise nvae


                elif LA6 == STRINGLITERAL:
                    LA6_14 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 14, self.input)

                        raise nvae


                elif LA6 == TRUE:
                    LA6_15 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 15, self.input)

                        raise nvae


                elif LA6 == FALSE:
                    LA6_16 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 16, self.input)

                        raise nvae


                elif LA6 == NULL:
                    LA6_17 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 17, self.input)

                        raise nvae


                elif LA6 == BOOLEAN:
                    LA6_18 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 18, self.input)

                        raise nvae


                elif LA6 == CHAR:
                    LA6_19 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 19, self.input)

                        raise nvae


                elif LA6 == BYTE:
                    LA6_20 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 20, self.input)

                        raise nvae


                elif LA6 == SHORT:
                    LA6_21 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 21, self.input)

                        raise nvae


                elif LA6 == INT:
                    LA6_22 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 22, self.input)

                        raise nvae


                elif LA6 == LONG:
                    LA6_23 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 23, self.input)

                        raise nvae


                elif LA6 == FLOAT:
                    LA6_24 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 24, self.input)

                        raise nvae


                elif LA6 == DOUBLE:
                    LA6_25 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 25, self.input)

                        raise nvae


                elif LA6 == VOID:
                    LA6_26 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 26, self.input)

                        raise nvae


                elif LA6 == 128:
                    LA6_27 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 27, self.input)

                        raise nvae


                elif LA6 == 126 or LA6 == 127:
                    LA6_28 = self.input.LA(2)

                    if (self.synpred5_JMLformulas()) :
                        alt6 = 1
                    elif (True) :
                        alt6 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 6, 28, self.input)

                        raise nvae


                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed


                    nvae = NoViableAltException("", 6, 0, self.input)

                    raise nvae


                if alt6 == 1:
                    # JMLformulas.g:169:9: ant= conditionalOrExpression ( '==>' ie= impliesNonBackwardExpression )*
                    pass 
                    self._state.following.append(self.FOLLOW_conditionalOrExpression_in_impliesExpression390)
                    ant = self.conditionalOrExpression()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                        l_props = []; 



                    # JMLformulas.g:171:9: ( '==>' ie= impliesNonBackwardExpression )*
                    while True: #loop4
                        alt4 = 2
                        LA4_0 = self.input.LA(1)

                        if (LA4_0 == 122) :
                            alt4 = 1


                        if alt4 == 1:
                            # JMLformulas.g:171:10: '==>' ie= impliesNonBackwardExpression
                            pass 
                            self.match(self.input, 122, self.FOLLOW_122_in_impliesExpression411)

                            self._state.following.append(self.FOLLOW_impliesNonBackwardExpression_in_impliesExpression415)
                            ie = self.impliesNonBackwardExpression()

                            self._state.following.pop()

                            if self._state.backtracking == 0:
                                pass
                                l_props.append(ie); 




                        else:
                            break #loop4


                    if self._state.backtracking == 0:
                        pass
                                
                        if len(l_props) == 0:
                           result =  ant
                        else:
                           result =  ImpliesExpression()
                           result.aggregate([ant] + l_props);





                elif alt6 == 2:
                    # JMLformulas.g:181:9: conditionalOrExpression ( '<==' conditionalOrExpression )+
                    pass 
                    self._state.following.append(self.FOLLOW_conditionalOrExpression_in_impliesExpression460)
                    self.conditionalOrExpression()

                    self._state.following.pop()

                    # JMLformulas.g:182:9: ( '<==' conditionalOrExpression )+
                    cnt5 = 0
                    while True: #loop5
                        alt5 = 2
                        LA5_0 = self.input.LA(1)

                        if (LA5_0 == 120) :
                            alt5 = 1


                        if alt5 == 1:
                            # JMLformulas.g:182:10: '<==' conditionalOrExpression
                            pass 
                            self.match(self.input, 120, self.FOLLOW_120_in_impliesExpression471)

                            self._state.following.append(self.FOLLOW_conditionalOrExpression_in_impliesExpression473)
                            self.conditionalOrExpression()

                            self._state.following.pop()


                        else:
                            if cnt5 >= 1:
                                break #loop5

                            if self._state.backtracking > 0:
                                raise BacktrackingFailed


                            eee = EarlyExitException(5, self.input)
                            raise eee

                        cnt5 += 1




                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 6, impliesExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "impliesExpression"



    # $ANTLR start "impliesNonBackwardExpression"
    # JMLformulas.g:186:1: impliesNonBackwardExpression returns [result] : ant= conditionalOrExpression ( '==>' ie= impliesNonBackwardExpression )* ;
    def impliesNonBackwardExpression(self, ):
        result = None

        impliesNonBackwardExpression_StartIndex = self.input.index()

        ant = None
        ie = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 7):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:187:5: (ant= conditionalOrExpression ( '==>' ie= impliesNonBackwardExpression )* )
                # JMLformulas.g:187:9: ant= conditionalOrExpression ( '==>' ie= impliesNonBackwardExpression )*
                pass 
                self._state.following.append(self.FOLLOW_conditionalOrExpression_in_impliesNonBackwardExpression509)
                ant = self.conditionalOrExpression()

                self._state.following.pop()

                if self._state.backtracking == 0:
                    pass
                    l_props = []; 



                # JMLformulas.g:189:9: ( '==>' ie= impliesNonBackwardExpression )*
                while True: #loop7
                    alt7 = 2
                    LA7_0 = self.input.LA(1)

                    if (LA7_0 == 122) :
                        LA7_2 = self.input.LA(2)

                        if (self.synpred7_JMLformulas()) :
                            alt7 = 1




                    if alt7 == 1:
                        # JMLformulas.g:189:10: '==>' ie= impliesNonBackwardExpression
                        pass 
                        self.match(self.input, 122, self.FOLLOW_122_in_impliesNonBackwardExpression530)

                        self._state.following.append(self.FOLLOW_impliesNonBackwardExpression_in_impliesNonBackwardExpression534)
                        ie = self.impliesNonBackwardExpression()

                        self._state.following.pop()

                        if self._state.backtracking == 0:
                            pass
                            l_props.append(ie); 




                    else:
                        break #loop7


                if self._state.backtracking == 0:
                    pass
                            
                    if len(l_props) == 0:
                        result =  ant
                    else:
                       result =  ImpliesExpression()
                       result.aggregate([ant] + l_props);







                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 7, impliesNonBackwardExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "impliesNonBackwardExpression"



    # $ANTLR start "conditionalOrExpression"
    # JMLformulas.g:201:1: conditionalOrExpression returns [result] : ant= conditionalAndExpression ( '||' ie= conditionalAndExpression )* ;
    def conditionalOrExpression(self, ):
        result = None

        conditionalOrExpression_StartIndex = self.input.index()

        ant = None
        ie = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 8):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:202:5: (ant= conditionalAndExpression ( '||' ie= conditionalAndExpression )* )
                # JMLformulas.g:202:9: ant= conditionalAndExpression ( '||' ie= conditionalAndExpression )*
                pass 
                self._state.following.append(self.FOLLOW_conditionalAndExpression_in_conditionalOrExpression594)
                ant = self.conditionalAndExpression()

                self._state.following.pop()

                if self._state.backtracking == 0:
                    pass
                    l_props = []; 



                # JMLformulas.g:204:9: ( '||' ie= conditionalAndExpression )*
                while True: #loop8
                    alt8 = 2
                    LA8_0 = self.input.LA(1)

                    if (LA8_0 == BARBAR) :
                        alt8 = 1


                    if alt8 == 1:
                        # JMLformulas.g:204:10: '||' ie= conditionalAndExpression
                        pass 
                        self.match(self.input, BARBAR, self.FOLLOW_BARBAR_in_conditionalOrExpression615)

                        self._state.following.append(self.FOLLOW_conditionalAndExpression_in_conditionalOrExpression619)
                        ie = self.conditionalAndExpression()

                        self._state.following.pop()

                        if self._state.backtracking == 0:
                            pass
                            l_props.append(ie); 




                    else:
                        break #loop8


                if self._state.backtracking == 0:
                    pass
                            
                    if len(l_props) == 0:
                       result =  ant
                    else:
                       result =  OrExpression()
                       result.aggregate([ant] + l_props);







                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 8, conditionalOrExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "conditionalOrExpression"



    # $ANTLR start "conditionalAndExpression"
    # JMLformulas.g:216:1: conditionalAndExpression returns [result] : ant= inclusiveOrExpression ( '&&' ie= inclusiveOrExpression )* ;
    def conditionalAndExpression(self, ):
        result = None

        conditionalAndExpression_StartIndex = self.input.index()

        ant = None
        ie = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 9):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:217:5: (ant= inclusiveOrExpression ( '&&' ie= inclusiveOrExpression )* )
                # JMLformulas.g:217:9: ant= inclusiveOrExpression ( '&&' ie= inclusiveOrExpression )*
                pass 
                self._state.following.append(self.FOLLOW_inclusiveOrExpression_in_conditionalAndExpression679)
                ant = self.inclusiveOrExpression()

                self._state.following.pop()

                if self._state.backtracking == 0:
                    pass
                    l_props = []; 



                # JMLformulas.g:219:9: ( '&&' ie= inclusiveOrExpression )*
                while True: #loop9
                    alt9 = 2
                    LA9_0 = self.input.LA(1)

                    if (LA9_0 == AMPAMP) :
                        alt9 = 1


                    if alt9 == 1:
                        # JMLformulas.g:219:10: '&&' ie= inclusiveOrExpression
                        pass 
                        self.match(self.input, AMPAMP, self.FOLLOW_AMPAMP_in_conditionalAndExpression700)

                        self._state.following.append(self.FOLLOW_inclusiveOrExpression_in_conditionalAndExpression704)
                        ie = self.inclusiveOrExpression()

                        self._state.following.pop()

                        if self._state.backtracking == 0:
                            pass
                            l_props.append(ie); 




                    else:
                        break #loop9


                if self._state.backtracking == 0:
                    pass
                            
                    if len(l_props) == 0:
                       result =  ant
                    else:
                       result =  AndExpression()
                       result.aggregate([ant] + l_props);







                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 9, conditionalAndExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "conditionalAndExpression"



    # $ANTLR start "inclusiveOrExpression"
    # JMLformulas.g:231:1: inclusiveOrExpression returns [result] : ant= exclusiveOrExpression ( '|' exclusiveOrExpression )* ;
    def inclusiveOrExpression(self, ):
        result = None

        inclusiveOrExpression_StartIndex = self.input.index()

        ant = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 10):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:232:5: (ant= exclusiveOrExpression ( '|' exclusiveOrExpression )* )
                # JMLformulas.g:232:9: ant= exclusiveOrExpression ( '|' exclusiveOrExpression )*
                pass 
                self._state.following.append(self.FOLLOW_exclusiveOrExpression_in_inclusiveOrExpression764)
                ant = self.exclusiveOrExpression()

                self._state.following.pop()

                # JMLformulas.g:233:9: ( '|' exclusiveOrExpression )*
                while True: #loop10
                    alt10 = 2
                    LA10_0 = self.input.LA(1)

                    if (LA10_0 == BAR) :
                        alt10 = 1


                    if alt10 == 1:
                        # JMLformulas.g:233:10: '|' exclusiveOrExpression
                        pass 
                        self.match(self.input, BAR, self.FOLLOW_BAR_in_inclusiveOrExpression775)

                        self._state.following.append(self.FOLLOW_exclusiveOrExpression_in_inclusiveOrExpression777)
                        self.exclusiveOrExpression()

                        self._state.following.pop()


                    else:
                        break #loop10


                if self._state.backtracking == 0:
                    pass
                    result =  ant 






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 10, inclusiveOrExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "inclusiveOrExpression"



    # $ANTLR start "exclusiveOrExpression"
    # JMLformulas.g:238:1: exclusiveOrExpression returns [result] : ant= andExpression ( '^' andExpression )* ;
    def exclusiveOrExpression(self, ):
        result = None

        exclusiveOrExpression_StartIndex = self.input.index()

        ant = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 11):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:239:5: (ant= andExpression ( '^' andExpression )* )
                # JMLformulas.g:239:9: ant= andExpression ( '^' andExpression )*
                pass 
                self._state.following.append(self.FOLLOW_andExpression_in_exclusiveOrExpression823)
                ant = self.andExpression()

                self._state.following.pop()

                # JMLformulas.g:240:9: ( '^' andExpression )*
                while True: #loop11
                    alt11 = 2
                    LA11_0 = self.input.LA(1)

                    if (LA11_0 == CARET) :
                        alt11 = 1


                    if alt11 == 1:
                        # JMLformulas.g:240:10: '^' andExpression
                        pass 
                        self.match(self.input, CARET, self.FOLLOW_CARET_in_exclusiveOrExpression834)

                        self._state.following.append(self.FOLLOW_andExpression_in_exclusiveOrExpression836)
                        self.andExpression()

                        self._state.following.pop()


                    else:
                        break #loop11


                if self._state.backtracking == 0:
                    pass
                    result =  ant 






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 11, exclusiveOrExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "exclusiveOrExpression"



    # $ANTLR start "andExpression"
    # JMLformulas.g:245:1: andExpression returns [result] : ant= equalityExpression ( '&' equalityExpression )* ;
    def andExpression(self, ):
        result = None

        andExpression_StartIndex = self.input.index()

        ant = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 12):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:246:5: (ant= equalityExpression ( '&' equalityExpression )* )
                # JMLformulas.g:246:9: ant= equalityExpression ( '&' equalityExpression )*
                pass 
                self._state.following.append(self.FOLLOW_equalityExpression_in_andExpression882)
                ant = self.equalityExpression()

                self._state.following.pop()

                # JMLformulas.g:247:9: ( '&' equalityExpression )*
                while True: #loop12
                    alt12 = 2
                    LA12_0 = self.input.LA(1)

                    if (LA12_0 == AMP) :
                        alt12 = 1


                    if alt12 == 1:
                        # JMLformulas.g:247:10: '&' equalityExpression
                        pass 
                        self.match(self.input, AMP, self.FOLLOW_AMP_in_andExpression893)

                        self._state.following.append(self.FOLLOW_equalityExpression_in_andExpression895)
                        self.equalityExpression()

                        self._state.following.pop()


                    else:
                        break #loop12


                if self._state.backtracking == 0:
                    pass
                    result =  ant 






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 12, andExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "andExpression"



    # $ANTLR start "equalityExpression"
    # JMLformulas.g:252:1: equalityExpression returns [result] : ant= instanceOfExpression ( ( '==' | '!=' ) ie= instanceOfExpression )* ;
    def equalityExpression(self, ):
        result = None

        equalityExpression_StartIndex = self.input.index()

        ant = None
        ie = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 13):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:253:5: (ant= instanceOfExpression ( ( '==' | '!=' ) ie= instanceOfExpression )* )
                # JMLformulas.g:253:9: ant= instanceOfExpression ( ( '==' | '!=' ) ie= instanceOfExpression )*
                pass 
                self._state.following.append(self.FOLLOW_instanceOfExpression_in_equalityExpression941)
                ant = self.instanceOfExpression()

                self._state.following.pop()

                if self._state.backtracking == 0:
                    pass
                    l_props = []; 



                # JMLformulas.g:255:9: ( ( '==' | '!=' ) ie= instanceOfExpression )*
                while True: #loop14
                    alt14 = 2
                    LA14_0 = self.input.LA(1)

                    if (LA14_0 == BANGEQ or LA14_0 == EQEQ) :
                        alt14 = 1


                    if alt14 == 1:
                        # JMLformulas.g:255:13: ( '==' | '!=' ) ie= instanceOfExpression
                        pass 
                        if self._state.backtracking == 0:
                            pass
                            l_x = None; 



                        # JMLformulas.g:256:13: ( '==' | '!=' )
                        alt13 = 2
                        LA13_0 = self.input.LA(1)

                        if (LA13_0 == EQEQ) :
                            alt13 = 1
                        elif (LA13_0 == BANGEQ) :
                            alt13 = 2
                        else:
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed


                            nvae = NoViableAltException("", 13, 0, self.input)

                            raise nvae


                        if alt13 == 1:
                            # JMLformulas.g:256:17: '=='
                            pass 
                            self.match(self.input, EQEQ, self.FOLLOW_EQEQ_in_equalityExpression983)

                            if self._state.backtracking == 0:
                                pass
                                l_x = EqualsExpression(); 




                        elif alt13 == 2:
                            # JMLformulas.g:257:17: '!='
                            pass 
                            self.match(self.input, BANGEQ, self.FOLLOW_BANGEQ_in_equalityExpression1004)

                            if self._state.backtracking == 0:
                                pass
                                l_x = NEqualsExpression(); 






                        self._state.following.append(self.FOLLOW_instanceOfExpression_in_equalityExpression1037)
                        ie = self.instanceOfExpression()

                        self._state.following.pop()

                        if self._state.backtracking == 0:
                            pass
                            l_props.append((l_x, ie)); 




                    else:
                        break #loop14


                if self._state.backtracking == 0:
                    pass
                            
                    dum = BinaryExpression();
                    if len(l_props) == 0:
                       result =  ant
                    else:
                       result =  dum.mix_aggregate([[ant]] + l_props)







                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 13, equalityExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "equalityExpression"



    # $ANTLR start "instanceOfExpression"
    # JMLformulas.g:271:1: instanceOfExpression returns [result] : relationalExpression ;
    def instanceOfExpression(self, ):
        result = None

        instanceOfExpression_StartIndex = self.input.index()

        relationalExpression4 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 14):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:272:5: ( relationalExpression )
                # JMLformulas.g:272:9: relationalExpression
                pass 
                self._state.following.append(self.FOLLOW_relationalExpression_in_instanceOfExpression1095)
                relationalExpression4 = self.relationalExpression()

                self._state.following.pop()

                if self._state.backtracking == 0:
                    pass
                    result =  relationalExpression4 






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 14, instanceOfExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "instanceOfExpression"



    # $ANTLR start "relationalExpression"
    # JMLformulas.g:276:1: relationalExpression returns [result] : ant= shiftExpression (op= relationalOp ie= shiftExpression )* ;
    def relationalExpression(self, ):
        result = None

        relationalExpression_StartIndex = self.input.index()

        ant = None
        op = None
        ie = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 15):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:277:5: (ant= shiftExpression (op= relationalOp ie= shiftExpression )* )
                # JMLformulas.g:277:9: ant= shiftExpression (op= relationalOp ie= shiftExpression )*
                pass 
                self._state.following.append(self.FOLLOW_shiftExpression_in_relationalExpression1130)
                ant = self.shiftExpression()

                self._state.following.pop()

                if self._state.backtracking == 0:
                    pass
                    l_props = []; 



                # JMLformulas.g:279:9: (op= relationalOp ie= shiftExpression )*
                while True: #loop15
                    alt15 = 2
                    LA15_0 = self.input.LA(1)

                    if (LA15_0 == GT or LA15_0 == LT or LA15_0 == 119 or LA15_0 == 123) :
                        alt15 = 1


                    if alt15 == 1:
                        # JMLformulas.g:279:10: op= relationalOp ie= shiftExpression
                        pass 
                        self._state.following.append(self.FOLLOW_relationalOp_in_relationalExpression1153)
                        op = self.relationalOp()

                        self._state.following.pop()

                        self._state.following.append(self.FOLLOW_shiftExpression_in_relationalExpression1157)
                        ie = self.shiftExpression()

                        self._state.following.pop()

                        if self._state.backtracking == 0:
                            pass
                            l_props.append((op, ie)); 




                    else:
                        break #loop15


                if self._state.backtracking == 0:
                    pass
                            
                    dum = BinaryExpression();
                    if len(l_props) == 0:
                       result =  ant
                    else:
                       result =  dum.mix_aggregate([[ant]] + l_props)







                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 15, relationalExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "relationalExpression"



    # $ANTLR start "relationalOp"
    # JMLformulas.g:291:1: relationalOp returns [result] : ( '<=' | '>=' | '<' | '>' );
    def relationalOp(self, ):
        result = None

        relationalOp_StartIndex = self.input.index()

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 16):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:292:5: ( '<=' | '>=' | '<' | '>' )
                alt16 = 4
                LA16 = self.input.LA(1)
                if LA16 == 119:
                    alt16 = 1
                elif LA16 == 123:
                    alt16 = 2
                elif LA16 == LT:
                    alt16 = 3
                elif LA16 == GT:
                    alt16 = 4
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed


                    nvae = NoViableAltException("", 16, 0, self.input)

                    raise nvae


                if alt16 == 1:
                    # JMLformulas.g:292:10: '<='
                    pass 
                    self.match(self.input, 119, self.FOLLOW_119_in_relationalOp1216)

                    if self._state.backtracking == 0:
                        pass
                        result =  LessEqualExpression() 




                elif alt16 == 2:
                    # JMLformulas.g:293:10: '>='
                    pass 
                    self.match(self.input, 123, self.FOLLOW_123_in_relationalOp1230)

                    if self._state.backtracking == 0:
                        pass
                        result =  GreaterEqualExpression() 




                elif alt16 == 3:
                    # JMLformulas.g:294:9: '<'
                    pass 
                    self.match(self.input, LT, self.FOLLOW_LT_in_relationalOp1243)

                    if self._state.backtracking == 0:
                        pass
                        result =  LessExpression() 




                elif alt16 == 4:
                    # JMLformulas.g:295:9: '>'
                    pass 
                    self.match(self.input, GT, self.FOLLOW_GT_in_relationalOp1258)

                    if self._state.backtracking == 0:
                        pass
                        result =  GreaterExpression() 





                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 16, relationalOp_StartIndex, success)


            pass
        return result

    # $ANTLR end "relationalOp"



    # $ANTLR start "shiftExpression"
    # JMLformulas.g:298:1: shiftExpression returns [result] : additiveExpression ;
    def shiftExpression(self, ):
        result = None

        shiftExpression_StartIndex = self.input.index()

        additiveExpression5 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 17):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:299:5: ( additiveExpression )
                # JMLformulas.g:299:9: additiveExpression
                pass 
                self._state.following.append(self.FOLLOW_additiveExpression_in_shiftExpression1286)
                additiveExpression5 = self.additiveExpression()

                self._state.following.pop()

                if self._state.backtracking == 0:
                    pass
                    result =  additiveExpression5 






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 17, shiftExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "shiftExpression"



    # $ANTLR start "additiveExpression"
    # JMLformulas.g:303:1: additiveExpression returns [result] : ant= multiplicativeExpression ( ( '+' | '-' ) ie= multiplicativeExpression )* ;
    def additiveExpression(self, ):
        result = None

        additiveExpression_StartIndex = self.input.index()

        ant = None
        ie = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 18):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:304:5: (ant= multiplicativeExpression ( ( '+' | '-' ) ie= multiplicativeExpression )* )
                # JMLformulas.g:304:9: ant= multiplicativeExpression ( ( '+' | '-' ) ie= multiplicativeExpression )*
                pass 
                self._state.following.append(self.FOLLOW_multiplicativeExpression_in_additiveExpression1321)
                ant = self.multiplicativeExpression()

                self._state.following.pop()

                if self._state.backtracking == 0:
                    pass
                    l_props = []; 



                # JMLformulas.g:306:9: ( ( '+' | '-' ) ie= multiplicativeExpression )*
                while True: #loop18
                    alt18 = 2
                    LA18_0 = self.input.LA(1)

                    if (LA18_0 == PLUS or LA18_0 == SUB) :
                        alt18 = 1


                    if alt18 == 1:
                        # JMLformulas.g:306:13: ( '+' | '-' ) ie= multiplicativeExpression
                        pass 
                        if self._state.backtracking == 0:
                            pass
                            l_x = None; 



                        # JMLformulas.g:307:13: ( '+' | '-' )
                        alt17 = 2
                        LA17_0 = self.input.LA(1)

                        if (LA17_0 == PLUS) :
                            alt17 = 1
                        elif (LA17_0 == SUB) :
                            alt17 = 2
                        else:
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed


                            nvae = NoViableAltException("", 17, 0, self.input)

                            raise nvae


                        if alt17 == 1:
                            # JMLformulas.g:307:17: '+'
                            pass 
                            self.match(self.input, PLUS, self.FOLLOW_PLUS_in_additiveExpression1363)

                            if self._state.backtracking == 0:
                                pass
                                l_x = AddExpression(); 




                        elif alt17 == 2:
                            # JMLformulas.g:308:17: '-'
                            pass 
                            self.match(self.input, SUB, self.FOLLOW_SUB_in_additiveExpression1384)

                            if self._state.backtracking == 0:
                                pass
                                l_x = SubExpression(); 






                        self._state.following.append(self.FOLLOW_multiplicativeExpression_in_additiveExpression1417)
                        ie = self.multiplicativeExpression()

                        self._state.following.pop()

                        if self._state.backtracking == 0:
                            pass
                            l_props.append((l_x, ie)); 




                    else:
                        break #loop18


                if self._state.backtracking == 0:
                    pass
                            
                    dum = BinaryExpression();
                    if len(l_props) == 0:
                       result =  ant
                    else:
                       result =  dum.mix_aggregate([[ant]] + l_props)







                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 18, additiveExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "additiveExpression"



    # $ANTLR start "multiplicativeExpression"
    # JMLformulas.g:322:1: multiplicativeExpression returns [result] : ant= unaryExpression ( ( '*' | '/' | '%' ) ie= unaryExpression )* ;
    def multiplicativeExpression(self, ):
        result = None

        multiplicativeExpression_StartIndex = self.input.index()

        ant = None
        ie = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 19):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:323:5: (ant= unaryExpression ( ( '*' | '/' | '%' ) ie= unaryExpression )* )
                # JMLformulas.g:323:8: ant= unaryExpression ( ( '*' | '/' | '%' ) ie= unaryExpression )*
                pass 
                self._state.following.append(self.FOLLOW_unaryExpression_in_multiplicativeExpression1477)
                ant = self.unaryExpression()

                self._state.following.pop()

                if self._state.backtracking == 0:
                    pass
                    l_props = []; 



                # JMLformulas.g:325:9: ( ( '*' | '/' | '%' ) ie= unaryExpression )*
                while True: #loop20
                    alt20 = 2
                    LA20_0 = self.input.LA(1)

                    if (LA20_0 == PERCENT or LA20_0 == SLASH or LA20_0 == STAR) :
                        alt20 = 1


                    if alt20 == 1:
                        # JMLformulas.g:325:13: ( '*' | '/' | '%' ) ie= unaryExpression
                        pass 
                        if self._state.backtracking == 0:
                            pass
                            l_x = None; 



                        # JMLformulas.g:326:13: ( '*' | '/' | '%' )
                        alt19 = 3
                        LA19 = self.input.LA(1)
                        if LA19 == STAR:
                            alt19 = 1
                        elif LA19 == SLASH:
                            alt19 = 2
                        elif LA19 == PERCENT:
                            alt19 = 3
                        else:
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed


                            nvae = NoViableAltException("", 19, 0, self.input)

                            raise nvae


                        if alt19 == 1:
                            # JMLformulas.g:326:17: '*'
                            pass 
                            self.match(self.input, STAR, self.FOLLOW_STAR_in_multiplicativeExpression1519)

                            if self._state.backtracking == 0:
                                pass
                                l_x = MultExpression(); 




                        elif alt19 == 2:
                            # JMLformulas.g:327:17: '/'
                            pass 
                            self.match(self.input, SLASH, self.FOLLOW_SLASH_in_multiplicativeExpression1540)

                            if self._state.backtracking == 0:
                                pass
                                l_x = DivExpression(); 




                        elif alt19 == 3:
                            # JMLformulas.g:328:17: '%'
                            pass 
                            self.match(self.input, PERCENT, self.FOLLOW_PERCENT_in_multiplicativeExpression1561)

                            if self._state.backtracking == 0:
                                pass
                                l_x = ModExpression(); 






                        self._state.following.append(self.FOLLOW_unaryExpression_in_multiplicativeExpression1594)
                        ie = self.unaryExpression()

                        self._state.following.pop()

                        if self._state.backtracking == 0:
                            pass
                            l_props.append((l_x, ie)); 




                    else:
                        break #loop20


                if self._state.backtracking == 0:
                    pass
                            
                    dum = BinaryExpression();
                    if len(l_props) == 0:
                       result =  ant
                    else:
                       result =  dum.mix_aggregate([[ant]] + l_props)







                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 19, multiplicativeExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "multiplicativeExpression"



    # $ANTLR start "unaryExpression"
    # JMLformulas.g:346:1: unaryExpression returns [result] : ( '+' ex= unaryExpression | '-' ex= unaryExpression | unaryExpressionNotPlusMinus );
    def unaryExpression(self, ):
        result = None

        unaryExpression_StartIndex = self.input.index()

        ex = None
        unaryExpressionNotPlusMinus6 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 20):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:347:5: ( '+' ex= unaryExpression | '-' ex= unaryExpression | unaryExpressionNotPlusMinus )
                alt21 = 3
                LA21 = self.input.LA(1)
                if LA21 == PLUS:
                    alt21 = 1
                elif LA21 == SUB:
                    alt21 = 2
                elif LA21 == BANG or LA21 == BOOLEAN or LA21 == BYTE or LA21 == CHAR or LA21 == CHARLITERAL or LA21 == DOUBLE or LA21 == DOUBLELITERAL or LA21 == FALSE or LA21 == FLOAT or LA21 == FLOATLITERAL or LA21 == IDENTIFIER or LA21 == INT or LA21 == INTLITERAL or LA21 == LONG or LA21 == LONGLITERAL or LA21 == LPAREN or LA21 == NULL or LA21 == SHORT or LA21 == STRINGLITERAL or LA21 == SUPER or LA21 == THIS or LA21 == TILDE or LA21 == TRUE or LA21 == VOID or LA21 == 126 or LA21 == 127 or LA21 == 128:
                    alt21 = 3
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed


                    nvae = NoViableAltException("", 21, 0, self.input)

                    raise nvae


                if alt21 == 1:
                    # JMLformulas.g:347:9: '+' ex= unaryExpression
                    pass 
                    self.match(self.input, PLUS, self.FOLLOW_PLUS_in_unaryExpression1654)

                    self._state.following.append(self.FOLLOW_unaryExpression_in_unaryExpression1659)
                    ex = self.unaryExpression()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                        result =  ex 




                elif alt21 == 2:
                    # JMLformulas.g:349:9: '-' ex= unaryExpression
                    pass 
                    self.match(self.input, SUB, self.FOLLOW_SUB_in_unaryExpression1679)

                    self._state.following.append(self.FOLLOW_unaryExpression_in_unaryExpression1683)
                    ex = self.unaryExpression()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                                 
                        result =  MinusUnaryExpression()
                        result.item = ex;





                elif alt21 == 3:
                    # JMLformulas.g:354:9: unaryExpressionNotPlusMinus
                    pass 
                    self._state.following.append(self.FOLLOW_unaryExpressionNotPlusMinus_in_unaryExpression1703)
                    unaryExpressionNotPlusMinus6 = self.unaryExpressionNotPlusMinus()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                        result =  unaryExpressionNotPlusMinus6 





                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 20, unaryExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "unaryExpression"



    # $ANTLR start "unaryExpressionNotPlusMinus"
    # JMLformulas.g:358:1: unaryExpressionNotPlusMinus returns [result] : ( '~' unaryExpression | '!' unaryExpression |t= primary ( selector )* );
    def unaryExpressionNotPlusMinus(self, ):
        result = None

        unaryExpressionNotPlusMinus_StartIndex = self.input.index()

        t = None
        unaryExpression7 = None
        unaryExpression8 = None
        selector9 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 21):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:359:5: ( '~' unaryExpression | '!' unaryExpression |t= primary ( selector )* )
                alt23 = 3
                LA23 = self.input.LA(1)
                if LA23 == TILDE:
                    alt23 = 1
                elif LA23 == BANG:
                    alt23 = 2
                elif LA23 == BOOLEAN or LA23 == BYTE or LA23 == CHAR or LA23 == CHARLITERAL or LA23 == DOUBLE or LA23 == DOUBLELITERAL or LA23 == FALSE or LA23 == FLOAT or LA23 == FLOATLITERAL or LA23 == IDENTIFIER or LA23 == INT or LA23 == INTLITERAL or LA23 == LONG or LA23 == LONGLITERAL or LA23 == LPAREN or LA23 == NULL or LA23 == SHORT or LA23 == STRINGLITERAL or LA23 == SUPER or LA23 == THIS or LA23 == TRUE or LA23 == VOID or LA23 == 126 or LA23 == 127 or LA23 == 128:
                    alt23 = 3
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed


                    nvae = NoViableAltException("", 23, 0, self.input)

                    raise nvae


                if alt23 == 1:
                    # JMLformulas.g:359:9: '~' unaryExpression
                    pass 
                    self.match(self.input, TILDE, self.FOLLOW_TILDE_in_unaryExpressionNotPlusMinus1736)

                    self._state.following.append(self.FOLLOW_unaryExpression_in_unaryExpressionNotPlusMinus1738)
                    unaryExpression7 = self.unaryExpression()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                        result =  unaryExpression7 




                elif alt23 == 2:
                    # JMLformulas.g:361:9: '!' unaryExpression
                    pass 
                    self.match(self.input, BANG, self.FOLLOW_BANG_in_unaryExpressionNotPlusMinus1758)

                    self._state.following.append(self.FOLLOW_unaryExpression_in_unaryExpressionNotPlusMinus1760)
                    unaryExpression8 = self.unaryExpression()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                                
                        result =  NotExpression()
                        result.item = unaryExpression8;





                elif alt23 == 3:
                    # JMLformulas.g:366:9: t= primary ( selector )*
                    pass 
                    self._state.following.append(self.FOLLOW_primary_in_unaryExpressionNotPlusMinus1782)
                    t = self.primary()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                        l_ss = []; 



                    # JMLformulas.g:368:9: ( selector )*
                    while True: #loop22
                        alt22 = 2
                        LA22_0 = self.input.LA(1)

                        if (LA22_0 == DOT or LA22_0 == LBRACKET) :
                            alt22 = 1


                        if alt22 == 1:
                            # JMLformulas.g:368:10: selector
                            pass 
                            self._state.following.append(self.FOLLOW_selector_in_unaryExpressionNotPlusMinus1803)
                            selector9 = self.selector()

                            self._state.following.pop()

                            if self._state.backtracking == 0:
                                pass
                                l_ss.append(selector9); 




                        else:
                            break #loop22


                    if self._state.backtracking == 0:
                        pass
                                
                        result = selsCombine(t, l_ss)






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 21, unaryExpressionNotPlusMinus_StartIndex, success)


            pass
        return result

    # $ANTLR end "unaryExpressionNotPlusMinus"



    # $ANTLR start "primary"
    # JMLformulas.g:379:1: primary returns [result] : ( parExpression | 'this' ( '.' id= IDENTIFIER )* (sf= identifierSuffix )? |tr= IDENTIFIER ( '.' id= IDENTIFIER )* (sf= identifierSuffix )? | 'super' superSuffix | literal | primitiveType ( '[' ']' )* '.' 'class' | 'void' '.' 'class' | jmlPrimary );
    def primary(self, ):
        result = None

        primary_StartIndex = self.input.index()

        id = None
        tr = None
        sf = None
        parExpression10 = None
        literal11 = None
        jmlPrimary12 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 22):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:380:5: ( parExpression | 'this' ( '.' id= IDENTIFIER )* (sf= identifierSuffix )? |tr= IDENTIFIER ( '.' id= IDENTIFIER )* (sf= identifierSuffix )? | 'super' superSuffix | literal | primitiveType ( '[' ']' )* '.' 'class' | 'void' '.' 'class' | jmlPrimary )
                alt29 = 8
                LA29 = self.input.LA(1)
                if LA29 == LPAREN:
                    LA29_1 = self.input.LA(2)

                    if (LA29_1 == BANG or LA29_1 == BOOLEAN or LA29_1 == BYTE or (CHAR <= LA29_1 <= CHARLITERAL) or (DOUBLE <= LA29_1 <= DOUBLELITERAL) or LA29_1 == FALSE or (FLOAT <= LA29_1 <= FLOATLITERAL) or LA29_1 == IDENTIFIER or LA29_1 == INT or LA29_1 == INTLITERAL or (LONG <= LA29_1 <= LPAREN) or LA29_1 == NULL or LA29_1 == PLUS or LA29_1 == SHORT or (STRINGLITERAL <= LA29_1 <= SUB) or LA29_1 == SUPER or LA29_1 == THIS or LA29_1 == TILDE or LA29_1 == TRUE or LA29_1 == VOID or (126 <= LA29_1 <= 128)) :
                        alt29 = 1
                    elif ((124 <= LA29_1 <= 125)) :
                        alt29 = 8
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 29, 1, self.input)

                        raise nvae


                elif LA29 == THIS:
                    alt29 = 2
                elif LA29 == IDENTIFIER:
                    alt29 = 3
                elif LA29 == SUPER:
                    alt29 = 4
                elif LA29 == CHARLITERAL or LA29 == DOUBLELITERAL or LA29 == FALSE or LA29 == FLOATLITERAL or LA29 == INTLITERAL or LA29 == LONGLITERAL or LA29 == NULL or LA29 == STRINGLITERAL or LA29 == TRUE:
                    alt29 = 5
                elif LA29 == BOOLEAN or LA29 == BYTE or LA29 == CHAR or LA29 == DOUBLE or LA29 == FLOAT or LA29 == INT or LA29 == LONG or LA29 == SHORT:
                    alt29 = 6
                elif LA29 == VOID:
                    alt29 = 7
                elif LA29 == 126 or LA29 == 127 or LA29 == 128:
                    alt29 = 8
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed


                    nvae = NoViableAltException("", 29, 0, self.input)

                    raise nvae


                if alt29 == 1:
                    # JMLformulas.g:380:9: parExpression
                    pass 
                    self._state.following.append(self.FOLLOW_parExpression_in_primary1863)
                    parExpression10 = self.parExpression()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                        result =  parExpression10 




                elif alt29 == 2:
                    # JMLformulas.g:382:9: 'this' ( '.' id= IDENTIFIER )* (sf= identifierSuffix )?
                    pass 
                    self.match(self.input, THIS, self.FOLLOW_THIS_in_primary1886)

                    if self._state.backtracking == 0:
                        pass
                                
                        l_t = Identifier();
                        l_t.val = l_t.THIS;
                        l_ids = [];
                        l_suf = None;




                    # JMLformulas.g:389:9: ( '.' id= IDENTIFIER )*
                    while True: #loop24
                        alt24 = 2
                        LA24_0 = self.input.LA(1)

                        if (LA24_0 == DOT) :
                            LA24_2 = self.input.LA(2)

                            if (LA24_2 == IDENTIFIER) :
                                LA24_3 = self.input.LA(3)

                                if (self.synpred30_JMLformulas()) :
                                    alt24 = 1






                        if alt24 == 1:
                            # JMLformulas.g:389:10: '.' id= IDENTIFIER
                            pass 
                            self.match(self.input, DOT, self.FOLLOW_DOT_in_primary1907)

                            id = self.match(self.input, IDENTIFIER, self.FOLLOW_IDENTIFIER_in_primary1911)

                            if self._state.backtracking == 0:
                                pass
                                             
                                l_id = Identifier()
                                l_id.val = id.text
                                l_ids.append(l_id); 





                        else:
                            break #loop24


                    # JMLformulas.g:396:9: (sf= identifierSuffix )?
                    alt25 = 2
                    LA25 = self.input.LA(1)
                    if LA25 == LBRACKET:
                        LA25_1 = self.input.LA(2)

                        if (self.synpred31_JMLformulas()) :
                            alt25 = 1
                    elif LA25 == LPAREN:
                        alt25 = 1
                    elif LA25 == DOT:
                        LA25_3 = self.input.LA(2)

                        if (self.synpred31_JMLformulas()) :
                            alt25 = 1
                    if alt25 == 1:
                        # JMLformulas.g:396:10: sf= identifierSuffix
                        pass 
                        self._state.following.append(self.FOLLOW_identifierSuffix_in_primary1949)
                        sf = self.identifierSuffix()

                        self._state.following.pop()

                        if self._state.backtracking == 0:
                            pass
                            l_suf = sf; 






                    if self._state.backtracking == 0:
                        pass
                                
                        result =  primaryCombine(l_t, l_ids, l_suf)





                elif alt29 == 3:
                    # JMLformulas.g:402:9: tr= IDENTIFIER ( '.' id= IDENTIFIER )* (sf= identifierSuffix )?
                    pass 
                    tr = self.match(self.input, IDENTIFIER, self.FOLLOW_IDENTIFIER_in_primary1996)

                    if self._state.backtracking == 0:
                        pass
                                
                        l_t = Identifier()
                        l_t.val = tr.text;
                        l_ids = [];
                        l_suf = None;




                    # JMLformulas.g:409:9: ( '.' id= IDENTIFIER )*
                    while True: #loop26
                        alt26 = 2
                        LA26_0 = self.input.LA(1)

                        if (LA26_0 == DOT) :
                            LA26_2 = self.input.LA(2)

                            if (LA26_2 == IDENTIFIER) :
                                LA26_3 = self.input.LA(3)

                                if (self.synpred33_JMLformulas()) :
                                    alt26 = 1






                        if alt26 == 1:
                            # JMLformulas.g:409:10: '.' id= IDENTIFIER
                            pass 
                            self.match(self.input, DOT, self.FOLLOW_DOT_in_primary2017)

                            id = self.match(self.input, IDENTIFIER, self.FOLLOW_IDENTIFIER_in_primary2021)

                            if self._state.backtracking == 0:
                                pass
                                             
                                l_id = Identifier()
                                l_id.val = id.text
                                l_ids.append(l_id); 





                        else:
                            break #loop26


                    # JMLformulas.g:416:9: (sf= identifierSuffix )?
                    alt27 = 2
                    LA27 = self.input.LA(1)
                    if LA27 == LBRACKET:
                        LA27_1 = self.input.LA(2)

                        if (self.synpred34_JMLformulas()) :
                            alt27 = 1
                    elif LA27 == LPAREN:
                        alt27 = 1
                    elif LA27 == DOT:
                        LA27_3 = self.input.LA(2)

                        if (self.synpred34_JMLformulas()) :
                            alt27 = 1
                    if alt27 == 1:
                        # JMLformulas.g:416:10: sf= identifierSuffix
                        pass 
                        self._state.following.append(self.FOLLOW_identifierSuffix_in_primary2059)
                        sf = self.identifierSuffix()

                        self._state.following.pop()

                        if self._state.backtracking == 0:
                            pass
                            l_suf = sf; 






                    if self._state.backtracking == 0:
                        pass
                                
                        result =  primaryCombine(l_t, l_ids, l_suf)





                elif alt29 == 4:
                    # JMLformulas.g:422:9: 'super' superSuffix
                    pass 
                    self.match(self.input, SUPER, self.FOLLOW_SUPER_in_primary2104)

                    self._state.following.append(self.FOLLOW_superSuffix_in_primary2114)
                    self.superSuffix()

                    self._state.following.pop()


                elif alt29 == 5:
                    # JMLformulas.g:424:9: literal
                    pass 
                    self._state.following.append(self.FOLLOW_literal_in_primary2124)
                    literal11 = self.literal()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                        result =  literal11 




                elif alt29 == 6:
                    # JMLformulas.g:426:9: primitiveType ( '[' ']' )* '.' 'class'
                    pass 
                    self._state.following.append(self.FOLLOW_primitiveType_in_primary2144)
                    self.primitiveType()

                    self._state.following.pop()

                    # JMLformulas.g:427:9: ( '[' ']' )*
                    while True: #loop28
                        alt28 = 2
                        LA28_0 = self.input.LA(1)

                        if (LA28_0 == LBRACKET) :
                            alt28 = 1


                        if alt28 == 1:
                            # JMLformulas.g:427:10: '[' ']'
                            pass 
                            self.match(self.input, LBRACKET, self.FOLLOW_LBRACKET_in_primary2155)

                            self.match(self.input, RBRACKET, self.FOLLOW_RBRACKET_in_primary2157)


                        else:
                            break #loop28


                    self.match(self.input, DOT, self.FOLLOW_DOT_in_primary2178)

                    self.match(self.input, CLASS, self.FOLLOW_CLASS_in_primary2180)


                elif alt29 == 7:
                    # JMLformulas.g:430:9: 'void' '.' 'class'
                    pass 
                    self.match(self.input, VOID, self.FOLLOW_VOID_in_primary2190)

                    self.match(self.input, DOT, self.FOLLOW_DOT_in_primary2192)

                    self.match(self.input, CLASS, self.FOLLOW_CLASS_in_primary2194)


                elif alt29 == 8:
                    # JMLformulas.g:431:9: jmlPrimary
                    pass 
                    self._state.following.append(self.FOLLOW_jmlPrimary_in_primary2204)
                    jmlPrimary12 = self.jmlPrimary()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                        result =  jmlPrimary12 





                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 22, primary_StartIndex, success)


            pass
        return result

    # $ANTLR end "primary"



    # $ANTLR start "primitiveType"
    # JMLformulas.g:435:1: primitiveType returns [result] : ( 'boolean' | 'char' | 'byte' | 'short' | 'int' | 'long' | 'float' | 'double' );
    def primitiveType(self, ):
        result = None

        primitiveType_StartIndex = self.input.index()

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 23):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:436:5: ( 'boolean' | 'char' | 'byte' | 'short' | 'int' | 'long' | 'float' | 'double' )
                alt30 = 8
                LA30 = self.input.LA(1)
                if LA30 == BOOLEAN:
                    alt30 = 1
                elif LA30 == CHAR:
                    alt30 = 2
                elif LA30 == BYTE:
                    alt30 = 3
                elif LA30 == SHORT:
                    alt30 = 4
                elif LA30 == INT:
                    alt30 = 5
                elif LA30 == LONG:
                    alt30 = 6
                elif LA30 == FLOAT:
                    alt30 = 7
                elif LA30 == DOUBLE:
                    alt30 = 8
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed


                    nvae = NoViableAltException("", 30, 0, self.input)

                    raise nvae


                if alt30 == 1:
                    # JMLformulas.g:436:9: 'boolean'
                    pass 
                    self.match(self.input, BOOLEAN, self.FOLLOW_BOOLEAN_in_primitiveType2238)

                    if self._state.backtracking == 0:
                        pass
                        result =  'boolean' 




                elif alt30 == 2:
                    # JMLformulas.g:438:9: 'char'
                    pass 
                    self.match(self.input, CHAR, self.FOLLOW_CHAR_in_primitiveType2258)

                    if self._state.backtracking == 0:
                        pass
                        result =  'char' 




                elif alt30 == 3:
                    # JMLformulas.g:440:9: 'byte'
                    pass 
                    self.match(self.input, BYTE, self.FOLLOW_BYTE_in_primitiveType2278)

                    if self._state.backtracking == 0:
                        pass
                        result =  'byte' 




                elif alt30 == 4:
                    # JMLformulas.g:442:9: 'short'
                    pass 
                    self.match(self.input, SHORT, self.FOLLOW_SHORT_in_primitiveType2298)

                    if self._state.backtracking == 0:
                        pass
                        result =  'short' 




                elif alt30 == 5:
                    # JMLformulas.g:444:9: 'int'
                    pass 
                    self.match(self.input, INT, self.FOLLOW_INT_in_primitiveType2318)

                    if self._state.backtracking == 0:
                        pass
                        result =  'int' 




                elif alt30 == 6:
                    # JMLformulas.g:446:9: 'long'
                    pass 
                    self.match(self.input, LONG, self.FOLLOW_LONG_in_primitiveType2338)

                    if self._state.backtracking == 0:
                        pass
                        result =  'long' 




                elif alt30 == 7:
                    # JMLformulas.g:448:9: 'float'
                    pass 
                    self.match(self.input, FLOAT, self.FOLLOW_FLOAT_in_primitiveType2358)

                    if self._state.backtracking == 0:
                        pass
                        result =  'float' 




                elif alt30 == 8:
                    # JMLformulas.g:450:9: 'double'
                    pass 
                    self.match(self.input, DOUBLE, self.FOLLOW_DOUBLE_in_primitiveType2378)

                    if self._state.backtracking == 0:
                        pass
                        result =  'double' 





                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 23, primitiveType_StartIndex, success)


            pass
        return result

    # $ANTLR end "primitiveType"



    # $ANTLR start "parExpression"
    # JMLformulas.g:454:1: parExpression returns [result] : '(' expression ')' ;
    def parExpression(self, ):
        result = None

        parExpression_StartIndex = self.input.index()

        expression13 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 24):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:455:5: ( '(' expression ')' )
                # JMLformulas.g:455:9: '(' expression ')'
                pass 
                self.match(self.input, LPAREN, self.FOLLOW_LPAREN_in_parExpression2415)

                self._state.following.append(self.FOLLOW_expression_in_parExpression2417)
                expression13 = self.expression()

                self._state.following.pop()

                self.match(self.input, RPAREN, self.FOLLOW_RPAREN_in_parExpression2419)

                if self._state.backtracking == 0:
                    pass
                    result =  expression13 






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 24, parExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "parExpression"



    # $ANTLR start "superSuffix"
    # JMLformulas.g:459:1: superSuffix : ( arguments | '.' IDENTIFIER ( arguments )? );
    def superSuffix(self, ):
        superSuffix_StartIndex = self.input.index()

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 25):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return 


                # JMLformulas.g:460:5: ( arguments | '.' IDENTIFIER ( arguments )? )
                alt32 = 2
                LA32_0 = self.input.LA(1)

                if (LA32_0 == LPAREN) :
                    alt32 = 1
                elif (LA32_0 == DOT) :
                    alt32 = 2
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed


                    nvae = NoViableAltException("", 32, 0, self.input)

                    raise nvae


                if alt32 == 1:
                    # JMLformulas.g:460:9: arguments
                    pass 
                    self._state.following.append(self.FOLLOW_arguments_in_superSuffix2450)
                    self.arguments()

                    self._state.following.pop()


                elif alt32 == 2:
                    # JMLformulas.g:461:9: '.' IDENTIFIER ( arguments )?
                    pass 
                    self.match(self.input, DOT, self.FOLLOW_DOT_in_superSuffix2460)

                    self.match(self.input, IDENTIFIER, self.FOLLOW_IDENTIFIER_in_superSuffix2471)

                    # JMLformulas.g:463:9: ( arguments )?
                    alt31 = 2
                    LA31_0 = self.input.LA(1)

                    if (LA31_0 == LPAREN) :
                        alt31 = 1
                    if alt31 == 1:
                        # JMLformulas.g:463:10: arguments
                        pass 
                        self._state.following.append(self.FOLLOW_arguments_in_superSuffix2482)
                        self.arguments()

                        self._state.following.pop()






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 25, superSuffix_StartIndex, success)


            pass
        return 

    # $ANTLR end "superSuffix"



    # $ANTLR start "identifierSuffix"
    # JMLformulas.g:467:1: identifierSuffix returns [args] : ( ( '[' ']' )+ '.' 'class' | ( '[' ex= expression ']' )+ | arguments | '.' 'class' | '.' 'this' | '.' 'super' arguments );
    def identifierSuffix(self, ):
        args = None

        identifierSuffix_StartIndex = self.input.index()

        ex = None
        arguments14 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 26):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return args


                # JMLformulas.g:468:5: ( ( '[' ']' )+ '.' 'class' | ( '[' ex= expression ']' )+ | arguments | '.' 'class' | '.' 'this' | '.' 'super' arguments )
                alt35 = 6
                LA35 = self.input.LA(1)
                if LA35 == LBRACKET:
                    LA35_1 = self.input.LA(2)

                    if (LA35_1 == RBRACKET) :
                        alt35 = 1
                    elif (LA35_1 == BANG or LA35_1 == BOOLEAN or LA35_1 == BYTE or (CHAR <= LA35_1 <= CHARLITERAL) or (DOUBLE <= LA35_1 <= DOUBLELITERAL) or LA35_1 == FALSE or (FLOAT <= LA35_1 <= FLOATLITERAL) or LA35_1 == IDENTIFIER or LA35_1 == INT or LA35_1 == INTLITERAL or (LONG <= LA35_1 <= LPAREN) or LA35_1 == NULL or LA35_1 == PLUS or LA35_1 == SHORT or (STRINGLITERAL <= LA35_1 <= SUB) or LA35_1 == SUPER or LA35_1 == THIS or LA35_1 == TILDE or LA35_1 == TRUE or LA35_1 == VOID or (126 <= LA35_1 <= 128)) :
                        alt35 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 35, 1, self.input)

                        raise nvae


                elif LA35 == LPAREN:
                    alt35 = 3
                elif LA35 == DOT:
                    LA35 = self.input.LA(2)
                    if LA35 == CLASS:
                        alt35 = 4
                    elif LA35 == THIS:
                        alt35 = 5
                    elif LA35 == SUPER:
                        alt35 = 6
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed


                        nvae = NoViableAltException("", 35, 3, self.input)

                        raise nvae


                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed


                    nvae = NoViableAltException("", 35, 0, self.input)

                    raise nvae


                if alt35 == 1:
                    # JMLformulas.g:468:9: ( '[' ']' )+ '.' 'class'
                    pass 
                    # JMLformulas.g:468:9: ( '[' ']' )+
                    cnt33 = 0
                    while True: #loop33
                        alt33 = 2
                        LA33_0 = self.input.LA(1)

                        if (LA33_0 == LBRACKET) :
                            alt33 = 1


                        if alt33 == 1:
                            # JMLformulas.g:468:10: '[' ']'
                            pass 
                            self.match(self.input, LBRACKET, self.FOLLOW_LBRACKET_in_identifierSuffix2517)

                            self.match(self.input, RBRACKET, self.FOLLOW_RBRACKET_in_identifierSuffix2519)


                        else:
                            if cnt33 >= 1:
                                break #loop33

                            if self._state.backtracking > 0:
                                raise BacktrackingFailed


                            eee = EarlyExitException(33, self.input)
                            raise eee

                        cnt33 += 1


                    self.match(self.input, DOT, self.FOLLOW_DOT_in_identifierSuffix2540)

                    self.match(self.input, CLASS, self.FOLLOW_CLASS_in_identifierSuffix2542)


                elif alt35 == 2:
                    # JMLformulas.g:471:9: ( '[' ex= expression ']' )+
                    pass 
                    if self._state.backtracking == 0:
                        pass
                        l_args = []; 



                    # JMLformulas.g:472:9: ( '[' ex= expression ']' )+
                    cnt34 = 0
                    while True: #loop34
                        alt34 = 2
                        LA34_0 = self.input.LA(1)

                        if (LA34_0 == LBRACKET) :
                            LA34_2 = self.input.LA(2)

                            if (self.synpred52_JMLformulas()) :
                                alt34 = 1




                        if alt34 == 1:
                            # JMLformulas.g:472:10: '[' ex= expression ']'
                            pass 
                            self.match(self.input, LBRACKET, self.FOLLOW_LBRACKET_in_identifierSuffix2563)

                            self._state.following.append(self.FOLLOW_expression_in_identifierSuffix2567)
                            ex = self.expression()

                            self._state.following.pop()

                            self.match(self.input, RBRACKET, self.FOLLOW_RBRACKET_in_identifierSuffix2569)

                            if self._state.backtracking == 0:
                                pass
                                l_args.append(ex); 




                        else:
                            if cnt34 >= 1:
                                break #loop34

                            if self._state.backtracking > 0:
                                raise BacktrackingFailed


                            eee = EarlyExitException(34, self.input)
                            raise eee

                        cnt34 += 1


                    if self._state.backtracking == 0:
                        pass
                        args =  ('[', l_args) 




                elif alt35 == 3:
                    # JMLformulas.g:476:9: arguments
                    pass 
                    self._state.following.append(self.FOLLOW_arguments_in_identifierSuffix2614)
                    arguments14 = self.arguments()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                        args =  ('(', arguments14) 




                elif alt35 == 4:
                    # JMLformulas.g:478:9: '.' 'class'
                    pass 
                    self.match(self.input, DOT, self.FOLLOW_DOT_in_identifierSuffix2634)

                    self.match(self.input, CLASS, self.FOLLOW_CLASS_in_identifierSuffix2636)


                elif alt35 == 5:
                    # JMLformulas.g:479:9: '.' 'this'
                    pass 
                    self.match(self.input, DOT, self.FOLLOW_DOT_in_identifierSuffix2646)

                    self.match(self.input, THIS, self.FOLLOW_THIS_in_identifierSuffix2648)


                elif alt35 == 6:
                    # JMLformulas.g:480:9: '.' 'super' arguments
                    pass 
                    self.match(self.input, DOT, self.FOLLOW_DOT_in_identifierSuffix2658)

                    self.match(self.input, SUPER, self.FOLLOW_SUPER_in_identifierSuffix2660)

                    self._state.following.append(self.FOLLOW_arguments_in_identifierSuffix2662)
                    self.arguments()

                    self._state.following.pop()



                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 26, identifierSuffix_StartIndex, success)


            pass
        return args

    # $ANTLR end "identifierSuffix"



    # $ANTLR start "selector"
    # JMLformulas.g:483:1: selector returns [sel] : ( '.' id= IDENTIFIER (aa= arguments )? | '[' expression ']' );
    def selector(self, ):
        sel = None

        selector_StartIndex = self.input.index()

        id = None
        aa = None
        expression15 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 27):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return sel


                # JMLformulas.g:484:5: ( '.' id= IDENTIFIER (aa= arguments )? | '[' expression ']' )
                alt37 = 2
                LA37_0 = self.input.LA(1)

                if (LA37_0 == DOT) :
                    alt37 = 1
                elif (LA37_0 == LBRACKET) :
                    alt37 = 2
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed


                    nvae = NoViableAltException("", 37, 0, self.input)

                    raise nvae


                if alt37 == 1:
                    # JMLformulas.g:484:9: '.' id= IDENTIFIER (aa= arguments )?
                    pass 
                    self.match(self.input, DOT, self.FOLLOW_DOT_in_selector2685)

                    id = self.match(self.input, IDENTIFIER, self.FOLLOW_IDENTIFIER_in_selector2689)

                    if self._state.backtracking == 0:
                        pass
                        l_args = None; 



                    # JMLformulas.g:486:9: (aa= arguments )?
                    alt36 = 2
                    LA36_0 = self.input.LA(1)

                    if (LA36_0 == LPAREN) :
                        alt36 = 1
                    if alt36 == 1:
                        # JMLformulas.g:486:10: aa= arguments
                        pass 
                        self._state.following.append(self.FOLLOW_arguments_in_selector2712)
                        aa = self.arguments()

                        self._state.following.pop()

                        if self._state.backtracking == 0:
                            pass
                            l_args = aa; 






                    if self._state.backtracking == 0:
                        pass
                                 
                        l_id = Identifier()
                        l_id.val = id.text
                        sel =  (l_id, l_args) 





                elif alt37 == 2:
                    # JMLformulas.g:494:9: '[' expression ']'
                    pass 
                    self.match(self.input, LBRACKET, self.FOLLOW_LBRACKET_in_selector2757)

                    self._state.following.append(self.FOLLOW_expression_in_selector2759)
                    expression15 = self.expression()

                    self._state.following.pop()

                    self.match(self.input, RBRACKET, self.FOLLOW_RBRACKET_in_selector2761)

                    if self._state.backtracking == 0:
                        pass
                        sel =  [expression15] 





                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 27, selector_StartIndex, success)


            pass
        return sel

    # $ANTLR end "selector"



    # $ANTLR start "createdName"
    # JMLformulas.g:498:1: createdName returns [result] : ( classOrInterfaceType | primitiveType );
    def createdName(self, ):
        result = None

        createdName_StartIndex = self.input.index()

        classOrInterfaceType16 = None
        primitiveType17 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 28):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:499:5: ( classOrInterfaceType | primitiveType )
                alt38 = 2
                LA38_0 = self.input.LA(1)

                if (LA38_0 == IDENTIFIER) :
                    alt38 = 1
                elif (LA38_0 == BOOLEAN or LA38_0 == BYTE or LA38_0 == CHAR or LA38_0 == DOUBLE or LA38_0 == FLOAT or LA38_0 == INT or LA38_0 == LONG or LA38_0 == SHORT) :
                    alt38 = 2
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed


                    nvae = NoViableAltException("", 38, 0, self.input)

                    raise nvae


                if alt38 == 1:
                    # JMLformulas.g:499:9: classOrInterfaceType
                    pass 
                    self._state.following.append(self.FOLLOW_classOrInterfaceType_in_createdName2794)
                    classOrInterfaceType16 = self.classOrInterfaceType()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                        result =  classOrInterfaceType16 




                elif alt38 == 2:
                    # JMLformulas.g:501:9: primitiveType
                    pass 
                    self._state.following.append(self.FOLLOW_primitiveType_in_createdName2814)
                    primitiveType17 = self.primitiveType()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                        result =  primitiveType17 





                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 28, createdName_StartIndex, success)


            pass
        return result

    # $ANTLR end "createdName"



    # $ANTLR start "classOrInterfaceType"
    # JMLformulas.g:505:1: classOrInterfaceType returns [result] : IDENTIFIER ;
    def classOrInterfaceType(self, ):
        result = None

        classOrInterfaceType_StartIndex = self.input.index()

        IDENTIFIER18 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 29):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:506:5: ( IDENTIFIER )
                # JMLformulas.g:506:9: IDENTIFIER
                pass 
                IDENTIFIER18 = self.match(self.input, IDENTIFIER, self.FOLLOW_IDENTIFIER_in_classOrInterfaceType2847)

                if self._state.backtracking == 0:
                    pass
                    result =  IDENTIFIER18.text 






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 29, classOrInterfaceType_StartIndex, success)


            pass
        return result

    # $ANTLR end "classOrInterfaceType"



    # $ANTLR start "arguments"
    # JMLformulas.g:510:1: arguments returns [args] : '(' (ex= expressionList )? ')' ;
    def arguments(self, ):
        args = None

        arguments_StartIndex = self.input.index()

        ex = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 30):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return args


                # JMLformulas.g:511:5: ( '(' (ex= expressionList )? ')' )
                # JMLformulas.g:511:9: '(' (ex= expressionList )? ')'
                pass 
                if self._state.backtracking == 0:
                    pass
                    l_args = []; 



                self.match(self.input, LPAREN, self.FOLLOW_LPAREN_in_arguments2890)

                # JMLformulas.g:512:13: (ex= expressionList )?
                alt39 = 2
                LA39_0 = self.input.LA(1)

                if (LA39_0 == BANG or LA39_0 == BOOLEAN or LA39_0 == BYTE or (CHAR <= LA39_0 <= CHARLITERAL) or (DOUBLE <= LA39_0 <= DOUBLELITERAL) or LA39_0 == FALSE or (FLOAT <= LA39_0 <= FLOATLITERAL) or LA39_0 == IDENTIFIER or LA39_0 == INT or LA39_0 == INTLITERAL or (LONG <= LA39_0 <= LPAREN) or LA39_0 == NULL or LA39_0 == PLUS or LA39_0 == SHORT or (STRINGLITERAL <= LA39_0 <= SUB) or LA39_0 == SUPER or LA39_0 == THIS or LA39_0 == TILDE or LA39_0 == TRUE or LA39_0 == VOID or (126 <= LA39_0 <= 128)) :
                    alt39 = 1
                if alt39 == 1:
                    # JMLformulas.g:512:14: ex= expressionList
                    pass 
                    self._state.following.append(self.FOLLOW_expressionList_in_arguments2895)
                    ex = self.expressionList()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                        l_args += ex; 






                self.match(self.input, RPAREN, self.FOLLOW_RPAREN_in_arguments2922)

                if self._state.backtracking == 0:
                    pass
                    args =  l_args 






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 30, arguments_StartIndex, success)


            pass
        return args

    # $ANTLR end "arguments"



    # $ANTLR start "expressionList"
    # JMLformulas.g:518:1: expressionList returns [args] :first= expression ( ',' ex= expression )* ;
    def expressionList(self, ):
        args = None

        expressionList_StartIndex = self.input.index()

        first = None
        ex = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 31):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return args


                # JMLformulas.g:519:5: (first= expression ( ',' ex= expression )* )
                # JMLformulas.g:519:9: first= expression ( ',' ex= expression )*
                pass 
                if self._state.backtracking == 0:
                    pass
                    l_args = []; 



                self._state.following.append(self.FOLLOW_expression_in_expressionList2967)
                first = self.expression()

                self._state.following.pop()

                # JMLformulas.g:521:9: ( ',' ex= expression )*
                while True: #loop40
                    alt40 = 2
                    LA40_0 = self.input.LA(1)

                    if (LA40_0 == COMMA) :
                        alt40 = 1


                    if alt40 == 1:
                        # JMLformulas.g:521:10: ',' ex= expression
                        pass 
                        self.match(self.input, COMMA, self.FOLLOW_COMMA_in_expressionList2978)

                        self._state.following.append(self.FOLLOW_expression_in_expressionList2982)
                        ex = self.expression()

                        self._state.following.pop()

                        if self._state.backtracking == 0:
                            pass
                            l_args.append(ex); 




                    else:
                        break #loop40


                if self._state.backtracking == 0:
                    pass
                    args =  [first] + l_args 






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 31, expressionList_StartIndex, success)


            pass
        return args

    # $ANTLR end "expressionList"



    # $ANTLR start "literal"
    # JMLformulas.g:527:1: literal returns [result] : ( INTLITERAL | LONGLITERAL | FLOATLITERAL | DOUBLELITERAL | CHARLITERAL | STRINGLITERAL | TRUE | FALSE | NULL );
    def literal(self, ):
        result = None

        literal_StartIndex = self.input.index()

        INTLITERAL19 = None
        LONGLITERAL20 = None
        FLOATLITERAL21 = None
        DOUBLELITERAL22 = None
        CHARLITERAL23 = None
        STRINGLITERAL24 = None
        TRUE25 = None
        FALSE26 = None
        NULL27 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 32):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:528:5: ( INTLITERAL | LONGLITERAL | FLOATLITERAL | DOUBLELITERAL | CHARLITERAL | STRINGLITERAL | TRUE | FALSE | NULL )
                alt41 = 9
                LA41 = self.input.LA(1)
                if LA41 == INTLITERAL:
                    alt41 = 1
                elif LA41 == LONGLITERAL:
                    alt41 = 2
                elif LA41 == FLOATLITERAL:
                    alt41 = 3
                elif LA41 == DOUBLELITERAL:
                    alt41 = 4
                elif LA41 == CHARLITERAL:
                    alt41 = 5
                elif LA41 == STRINGLITERAL:
                    alt41 = 6
                elif LA41 == TRUE:
                    alt41 = 7
                elif LA41 == FALSE:
                    alt41 = 8
                elif LA41 == NULL:
                    alt41 = 9
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed


                    nvae = NoViableAltException("", 41, 0, self.input)

                    raise nvae


                if alt41 == 1:
                    # JMLformulas.g:528:9: INTLITERAL
                    pass 
                    INTLITERAL19 = self.match(self.input, INTLITERAL, self.FOLLOW_INTLITERAL_in_literal3040)

                    if self._state.backtracking == 0:
                        pass
                                 
                        result =  Literal()
                        l_t = PrimitiveType();
                        l_t.idt = l_t.INT;
                        result.typ = l_t;
                        result.val = int(INTLITERAL19.text);





                elif alt41 == 2:
                    # JMLformulas.g:536:9: LONGLITERAL
                    pass 
                    LONGLITERAL20 = self.match(self.input, LONGLITERAL, self.FOLLOW_LONGLITERAL_in_literal3060)

                    if self._state.backtracking == 0:
                        pass
                                 
                        result =  Literal()
                        l_t = PrimitiveType();
                        l_t.idt = l_t.LONG;
                        result.typ = l_t;
                        result.val = int(LONGLITERAL20.text);





                elif alt41 == 3:
                    # JMLformulas.g:544:9: FLOATLITERAL
                    pass 
                    FLOATLITERAL21 = self.match(self.input, FLOATLITERAL, self.FOLLOW_FLOATLITERAL_in_literal3080)

                    if self._state.backtracking == 0:
                        pass
                                 
                        result =  Literal()
                        result.val = float(FLOATLITERAL21.text);





                elif alt41 == 4:
                    # JMLformulas.g:549:9: DOUBLELITERAL
                    pass 
                    DOUBLELITERAL22 = self.match(self.input, DOUBLELITERAL, self.FOLLOW_DOUBLELITERAL_in_literal3100)

                    if self._state.backtracking == 0:
                        pass
                                 
                        result =  Literal()
                        l_t = PrimitiveType();
                        l_t.idt = l_t.DOUBLE;
                        result.typ = l_t;
                        result.val = float(DOUBLELITERAL22.text);





                elif alt41 == 5:
                    # JMLformulas.g:557:9: CHARLITERAL
                    pass 
                    CHARLITERAL23 = self.match(self.input, CHARLITERAL, self.FOLLOW_CHARLITERAL_in_literal3120)

                    if self._state.backtracking == 0:
                        pass
                                 
                        result =  Literal()
                        l_t = PrimitiveType();
                        l_t.idt = l_t.CHAR;
                        result.typ = l_t;
                        result.val = CHARLITERAL23.text;





                elif alt41 == 6:
                    # JMLformulas.g:565:9: STRINGLITERAL
                    pass 
                    STRINGLITERAL24 = self.match(self.input, STRINGLITERAL, self.FOLLOW_STRINGLITERAL_in_literal3140)

                    if self._state.backtracking == 0:
                        pass
                                 
                        result =  Literal()
                        result.val = STRINGLITERAL24.text;





                elif alt41 == 7:
                    # JMLformulas.g:570:9: TRUE
                    pass 
                    TRUE25 = self.match(self.input, TRUE, self.FOLLOW_TRUE_in_literal3160)

                    if self._state.backtracking == 0:
                        pass
                                 
                        result =  Literal()
                        l_t = PrimitiveType();
                        l_t.idt = l_t.BOOLEAN;
                        result.typ = l_t;
                        result.val = TRUE25.text;





                elif alt41 == 8:
                    # JMLformulas.g:578:9: FALSE
                    pass 
                    FALSE26 = self.match(self.input, FALSE, self.FOLLOW_FALSE_in_literal3180)

                    if self._state.backtracking == 0:
                        pass
                                 
                        result =  Literal()
                        l_t = PrimitiveType();
                        l_t.idt = l_t.BOOLEAN;
                        result.typ = l_t;
                        result.val = FALSE26.text;





                elif alt41 == 9:
                    # JMLformulas.g:586:9: NULL
                    pass 
                    NULL27 = self.match(self.input, NULL, self.FOLLOW_NULL_in_literal3200)

                    if self._state.backtracking == 0:
                        pass
                                 
                        result =  Literal()
                        result.val = NULL27.text;






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 32, literal_StartIndex, success)


            pass
        return result

    # $ANTLR end "literal"



    # $ANTLR start "jmlPrimary"
    # JMLformulas.g:594:1: jmlPrimary returns [result] : ( resultExpression | oldExpression | specQuantifiedExpression );
    def jmlPrimary(self, ):
        result = None

        jmlPrimary_StartIndex = self.input.index()

        resultExpression28 = None
        oldExpression29 = None
        specQuantifiedExpression30 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 33):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:595:5: ( resultExpression | oldExpression | specQuantifiedExpression )
                alt42 = 3
                LA42 = self.input.LA(1)
                if LA42 == 128:
                    alt42 = 1
                elif LA42 == 126 or LA42 == 127:
                    alt42 = 2
                elif LA42 == LPAREN:
                    alt42 = 3
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed


                    nvae = NoViableAltException("", 42, 0, self.input)

                    raise nvae


                if alt42 == 1:
                    # JMLformulas.g:595:9: resultExpression
                    pass 
                    self._state.following.append(self.FOLLOW_resultExpression_in_jmlPrimary3234)
                    resultExpression28 = self.resultExpression()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                        result =  resultExpression28 




                elif alt42 == 2:
                    # JMLformulas.g:597:9: oldExpression
                    pass 
                    self._state.following.append(self.FOLLOW_oldExpression_in_jmlPrimary3254)
                    oldExpression29 = self.oldExpression()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                        result =  oldExpression29 




                elif alt42 == 3:
                    # JMLformulas.g:599:9: specQuantifiedExpression
                    pass 
                    self._state.following.append(self.FOLLOW_specQuantifiedExpression_in_jmlPrimary3274)
                    specQuantifiedExpression30 = self.specQuantifiedExpression()

                    self._state.following.pop()

                    if self._state.backtracking == 0:
                        pass
                        result =  specQuantifiedExpression30 





                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 33, jmlPrimary_StartIndex, success)


            pass
        return result

    # $ANTLR end "jmlPrimary"



    # $ANTLR start "resultExpression"
    # JMLformulas.g:603:1: resultExpression returns [result] : '\\\\result' ;
    def resultExpression(self, ):
        result = None

        resultExpression_StartIndex = self.input.index()

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 34):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:604:5: ( '\\\\result' )
                # JMLformulas.g:604:9: '\\\\result'
                pass 
                self.match(self.input, 128, self.FOLLOW_128_in_resultExpression3307)

                if self._state.backtracking == 0:
                    pass
                    result =  ResultExpression() 






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 34, resultExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "resultExpression"



    # $ANTLR start "oldExpression"
    # JMLformulas.g:608:1: oldExpression returns [result] : oldId '(' specExpression ')' ;
    def oldExpression(self, ):
        result = None

        oldExpression_StartIndex = self.input.index()

        specExpression31 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 35):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:609:5: ( oldId '(' specExpression ')' )
                # JMLformulas.g:609:9: oldId '(' specExpression ')'
                pass 
                self._state.following.append(self.FOLLOW_oldId_in_oldExpression3340)
                self.oldId()

                self._state.following.pop()

                self.match(self.input, LPAREN, self.FOLLOW_LPAREN_in_oldExpression3342)

                self._state.following.append(self.FOLLOW_specExpression_in_oldExpression3344)
                specExpression31 = self.specExpression()

                self._state.following.pop()

                self.match(self.input, RPAREN, self.FOLLOW_RPAREN_in_oldExpression3346)

                if self._state.backtracking == 0:
                    pass
                            
                    result = OldExpression()
                    result.args = [specExpression31]







                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 35, oldExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "oldExpression"



    # $ANTLR start "specExpression"
    # JMLformulas.g:616:1: specExpression returns [result] : expression ;
    def specExpression(self, ):
        result = None

        specExpression_StartIndex = self.input.index()

        expression32 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 36):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:617:5: ( expression )
                # JMLformulas.g:617:9: expression
                pass 
                self._state.following.append(self.FOLLOW_expression_in_specExpression3379)
                expression32 = self.expression()

                self._state.following.pop()

                if self._state.backtracking == 0:
                    pass
                    result =  expression32 






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 36, specExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "specExpression"



    # $ANTLR start "oldId"
    # JMLformulas.g:621:1: oldId : ( '\\\\old' | '\\\\pre' );
    def oldId(self, ):
        oldId_StartIndex = self.input.index()

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 37):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return 


                # JMLformulas.g:622:5: ( '\\\\old' | '\\\\pre' )
                # JMLformulas.g:
                pass 
                if (126 <= self.input.LA(1) <= 127):
                    self.input.consume()
                    self._state.errorRecovery = False


                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed


                    mse = MismatchedSetException(None, self.input)
                    raise mse






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 37, oldId_StartIndex, success)


            pass
        return 

    # $ANTLR end "oldId"



    # $ANTLR start "specQuantifiedExpression"
    # JMLformulas.g:626:1: specQuantifiedExpression returns [result] : '(' quantifier quantifiedVarDecls ';' ( ( predicate )? ';' )? specExpression ')' ;
    def specQuantifiedExpression(self, ):
        result = None

        specQuantifiedExpression_StartIndex = self.input.index()

        quantifier33 = None
        quantifiedVarDecls34 = None
        predicate35 = None
        specExpression36 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 38):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:627:5: ( '(' quantifier quantifiedVarDecls ';' ( ( predicate )? ';' )? specExpression ')' )
                # JMLformulas.g:627:9: '(' quantifier quantifiedVarDecls ';' ( ( predicate )? ';' )? specExpression ')'
                pass 
                self.match(self.input, LPAREN, self.FOLLOW_LPAREN_in_specQuantifiedExpression3441)

                self._state.following.append(self.FOLLOW_quantifier_in_specQuantifiedExpression3452)
                quantifier33 = self.quantifier()

                self._state.following.pop()

                self._state.following.append(self.FOLLOW_quantifiedVarDecls_in_specQuantifiedExpression3454)
                quantifiedVarDecls34 = self.quantifiedVarDecls()

                self._state.following.pop()

                self.match(self.input, SEMI, self.FOLLOW_SEMI_in_specQuantifiedExpression3456)

                if self._state.backtracking == 0:
                    pass
                    l_wp = False; 



                # JMLformulas.g:630:9: ( ( predicate )? ';' )?
                alt44 = 2
                LA44 = self.input.LA(1)
                if LA44 == PLUS:
                    LA44_1 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == SUB:
                    LA44_2 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == TILDE:
                    LA44_3 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == BANG:
                    LA44_4 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == LPAREN:
                    LA44_5 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == THIS:
                    LA44_6 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == IDENTIFIER:
                    LA44_7 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == SUPER:
                    LA44_8 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == INTLITERAL:
                    LA44_9 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == LONGLITERAL:
                    LA44_10 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == FLOATLITERAL:
                    LA44_11 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == DOUBLELITERAL:
                    LA44_12 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == CHARLITERAL:
                    LA44_13 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == STRINGLITERAL:
                    LA44_14 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == TRUE:
                    LA44_15 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == FALSE:
                    LA44_16 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == NULL:
                    LA44_17 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == BOOLEAN:
                    LA44_18 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == CHAR:
                    LA44_19 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == BYTE:
                    LA44_20 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == SHORT:
                    LA44_21 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == INT:
                    LA44_22 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == LONG:
                    LA44_23 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == FLOAT:
                    LA44_24 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == DOUBLE:
                    LA44_25 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == VOID:
                    LA44_26 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == 128:
                    LA44_27 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == 126 or LA44 == 127:
                    LA44_28 = self.input.LA(2)

                    if (self.synpred74_JMLformulas()) :
                        alt44 = 1
                elif LA44 == SEMI:
                    alt44 = 1
                if alt44 == 1:
                    # JMLformulas.g:630:11: ( predicate )? ';'
                    pass 
                    # JMLformulas.g:630:11: ( predicate )?
                    alt43 = 2
                    LA43_0 = self.input.LA(1)

                    if (LA43_0 == BANG or LA43_0 == BOOLEAN or LA43_0 == BYTE or (CHAR <= LA43_0 <= CHARLITERAL) or (DOUBLE <= LA43_0 <= DOUBLELITERAL) or LA43_0 == FALSE or (FLOAT <= LA43_0 <= FLOATLITERAL) or LA43_0 == IDENTIFIER or LA43_0 == INT or LA43_0 == INTLITERAL or (LONG <= LA43_0 <= LPAREN) or LA43_0 == NULL or LA43_0 == PLUS or LA43_0 == SHORT or (STRINGLITERAL <= LA43_0 <= SUB) or LA43_0 == SUPER or LA43_0 == THIS or LA43_0 == TILDE or LA43_0 == TRUE or LA43_0 == VOID or (126 <= LA43_0 <= 128)) :
                        alt43 = 1
                    if alt43 == 1:
                        # JMLformulas.g:630:12: predicate
                        pass 
                        self._state.following.append(self.FOLLOW_predicate_in_specQuantifiedExpression3480)
                        predicate35 = self.predicate()

                        self._state.following.pop()

                        if self._state.backtracking == 0:
                            pass
                            l_wp = True; 






                    self.match(self.input, SEMI, self.FOLLOW_SEMI_in_specQuantifiedExpression3487)




                self._state.following.append(self.FOLLOW_specExpression_in_specQuantifiedExpression3500)
                specExpression36 = self.specExpression()

                self._state.following.pop()

                self.match(self.input, RPAREN, self.FOLLOW_RPAREN_in_specQuantifiedExpression3510)

                if self._state.backtracking == 0:
                    pass
                            
                    result =  quantifier33
                    result.variables = quantifiedVarDecls34
                    if l_wp:
                       ex = ImpliesExpression()
                       ex.left = predicate35
                       ex.right = specExpression36
                    else:
                       ex = specExpression36
                    result.scope = ex







                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 38, specQuantifiedExpression_StartIndex, success)


            pass
        return result

    # $ANTLR end "specQuantifiedExpression"



    # $ANTLR start "quantifier"
    # JMLformulas.g:646:1: quantifier returns [result] : ( '\\\\forall' | '\\\\exists' );
    def quantifier(self, ):
        result = None

        quantifier_StartIndex = self.input.index()

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 39):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:647:5: ( '\\\\forall' | '\\\\exists' )
                alt45 = 2
                LA45_0 = self.input.LA(1)

                if (LA45_0 == 125) :
                    alt45 = 1
                elif (LA45_0 == 124) :
                    alt45 = 2
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed


                    nvae = NoViableAltException("", 45, 0, self.input)

                    raise nvae


                if alt45 == 1:
                    # JMLformulas.g:647:9: '\\\\forall'
                    pass 
                    self.match(self.input, 125, self.FOLLOW_125_in_quantifier3543)

                    if self._state.backtracking == 0:
                        pass
                                 
                        result =  QuantifiedExpression()
                        result.quantifier = result.FORALL;





                elif alt45 == 2:
                    # JMLformulas.g:652:9: '\\\\exists'
                    pass 
                    self.match(self.input, 124, self.FOLLOW_124_in_quantifier3564)

                    if self._state.backtracking == 0:
                        pass
                                 
                        result =  QuantifiedExpression()
                        result.quantifier = result.EXISTS;






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 39, quantifier_StartIndex, success)


            pass
        return result

    # $ANTLR end "quantifier"



    # $ANTLR start "quantifiedVarDecls"
    # JMLformulas.g:659:1: quantifiedVarDecls returns [vars] : first= normalParameterDecl ( ',' pd= normalParameterDecl )* ;
    def quantifiedVarDecls(self, ):
        vars = None

        quantifiedVarDecls_StartIndex = self.input.index()

        first = None
        pd = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 40):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return vars


                # JMLformulas.g:660:5: (first= normalParameterDecl ( ',' pd= normalParameterDecl )* )
                # JMLformulas.g:660:9: first= normalParameterDecl ( ',' pd= normalParameterDecl )*
                pass 
                self._state.following.append(self.FOLLOW_normalParameterDecl_in_quantifiedVarDecls3599)
                first = self.normalParameterDecl()

                self._state.following.pop()

                if self._state.backtracking == 0:
                    pass
                    l_vs = first; 



                # JMLformulas.g:662:9: ( ',' pd= normalParameterDecl )*
                while True: #loop46
                    alt46 = 2
                    LA46_0 = self.input.LA(1)

                    if (LA46_0 == COMMA) :
                        alt46 = 1


                    if alt46 == 1:
                        # JMLformulas.g:662:10: ',' pd= normalParameterDecl
                        pass 
                        self.match(self.input, COMMA, self.FOLLOW_COMMA_in_quantifiedVarDecls3620)

                        self._state.following.append(self.FOLLOW_normalParameterDecl_in_quantifiedVarDecls3624)
                        pd = self.normalParameterDecl()

                        self._state.following.pop()

                        if self._state.backtracking == 0:
                            pass
                            l_vs += pd; 




                    else:
                        break #loop46


                if self._state.backtracking == 0:
                    pass
                    vars =  l_vs 






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 40, quantifiedVarDecls_StartIndex, success)


            pass
        return vars

    # $ANTLR end "quantifiedVarDecls"



    # $ANTLR start "normalParameterDecl"
    # JMLformulas.g:668:1: normalParameterDecl returns [vars] : t= createdName ( '[' ']' )* fid= IDENTIFIER ( ',' id= IDENTIFIER )* ;
    def normalParameterDecl(self, ):
        vars = None

        normalParameterDecl_StartIndex = self.input.index()

        fid = None
        id = None
        t = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 41):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return vars


                # JMLformulas.g:669:5: (t= createdName ( '[' ']' )* fid= IDENTIFIER ( ',' id= IDENTIFIER )* )
                # JMLformulas.g:669:9: t= createdName ( '[' ']' )* fid= IDENTIFIER ( ',' id= IDENTIFIER )*
                pass 
                self._state.following.append(self.FOLLOW_createdName_in_normalParameterDecl3684)
                t = self.createdName()

                self._state.following.pop()

                if self._state.backtracking == 0:
                    pass
                    l_at = 0; 



                # JMLformulas.g:671:9: ( '[' ']' )*
                while True: #loop47
                    alt47 = 2
                    LA47_0 = self.input.LA(1)

                    if (LA47_0 == LBRACKET) :
                        alt47 = 1


                    if alt47 == 1:
                        # JMLformulas.g:671:10: '[' ']'
                        pass 
                        self.match(self.input, LBRACKET, self.FOLLOW_LBRACKET_in_normalParameterDecl3706)

                        self.match(self.input, RBRACKET, self.FOLLOW_RBRACKET_in_normalParameterDecl3708)

                        if self._state.backtracking == 0:
                            pass
                            l_at = l_at + 1; 




                    else:
                        break #loop47


                fid = self.match(self.input, IDENTIFIER, self.FOLLOW_IDENTIFIER_in_normalParameterDecl3746)

                if self._state.backtracking == 0:
                    pass
                            
                    l_fid = Identifier();
                    l_fid.val = fid.text;
                    l_ids = [l_fid];




                # JMLformulas.g:680:9: ( ',' id= IDENTIFIER )*
                while True: #loop48
                    alt48 = 2
                    LA48_0 = self.input.LA(1)

                    if (LA48_0 == COMMA) :
                        LA48_1 = self.input.LA(2)

                        if (LA48_1 == IDENTIFIER) :
                            LA48_3 = self.input.LA(3)

                            if (LA48_3 == EOF or LA48_3 == COMMA or LA48_3 == SEMI) :
                                alt48 = 1






                    if alt48 == 1:
                        # JMLformulas.g:680:10: ',' id= IDENTIFIER
                        pass 
                        self.match(self.input, COMMA, self.FOLLOW_COMMA_in_normalParameterDecl3767)

                        id = self.match(self.input, IDENTIFIER, self.FOLLOW_IDENTIFIER_in_normalParameterDecl3771)

                        if self._state.backtracking == 0:
                            pass
                                        
                            l_id = Identifier();
                            l_id.val = id.text;
                            l_ids.append(l_id);





                    else:
                        break #loop48


                if self._state.backtracking == 0:
                    pass
                            
                    l_t = Type()
                    l_t.idt = t
                    if l_at == 0:
                       l_rt = l_t
                    else:
                       l_rt = ArrayType()
                       l_rt.basetyp = l_t
                       l_dim = l_at
                    vars = []
                    for x in l_ids:
                       l_v = QuantifiedVariable()
                       l_v.typ = l_rt
                       l_v.val = x
                       vars.append(l_v)







                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 41, normalParameterDecl_StartIndex, success)


            pass
        return vars

    # $ANTLR end "normalParameterDecl"



    # $ANTLR start "predicate"
    # JMLformulas.g:705:1: predicate returns [result] : specExpression ;
    def predicate(self, ):
        result = None

        predicate_StartIndex = self.input.index()

        specExpression37 = None

        success = False

        try:
            try:
                if self._state.backtracking > 0 and self.alreadyParsedRule(self.input, 42):
                    # for cached failed rules, alreadyParsedRule will raise an exception
                    success = True
                    return result


                # JMLformulas.g:706:5: ( specExpression )
                # JMLformulas.g:706:9: specExpression
                pass 
                self._state.following.append(self.FOLLOW_specExpression_in_predicate3829)
                specExpression37 = self.specExpression()

                self._state.following.pop()

                if self._state.backtracking == 0:
                    pass
                    result =  specExpression37 






                success = True

                       
            except RecognitionException, re:
            # No error reporting: just give up
            #    self.reportError(re)
                self.recover(self.input, re)

        finally:
            if self._state.backtracking > 0:
                self.memoize(self.input, 42, predicate_StartIndex, success)


            pass
        return result

    # $ANTLR end "predicate"

    # $ANTLR start "synpred5_JMLformulas"
    def synpred5_JMLformulas_fragment(self, ):
        ant = None
        ie = None

        # JMLformulas.g:169:9: (ant= conditionalOrExpression ( '==>' ie= impliesNonBackwardExpression )* )
        # JMLformulas.g:169:9: ant= conditionalOrExpression ( '==>' ie= impliesNonBackwardExpression )*
        pass 
        self._state.following.append(self.FOLLOW_conditionalOrExpression_in_synpred5_JMLformulas390)
        ant = self.conditionalOrExpression()

        self._state.following.pop()

        # JMLformulas.g:171:9: ( '==>' ie= impliesNonBackwardExpression )*
        while True: #loop49
            alt49 = 2
            LA49_0 = self.input.LA(1)

            if (LA49_0 == 122) :
                alt49 = 1


            if alt49 == 1:
                # JMLformulas.g:171:10: '==>' ie= impliesNonBackwardExpression
                pass 
                self.match(self.input, 122, self.FOLLOW_122_in_synpred5_JMLformulas411)

                self._state.following.append(self.FOLLOW_impliesNonBackwardExpression_in_synpred5_JMLformulas415)
                ie = self.impliesNonBackwardExpression()

                self._state.following.pop()


            else:
                break #loop49




    # $ANTLR end "synpred5_JMLformulas"



    # $ANTLR start "synpred7_JMLformulas"
    def synpred7_JMLformulas_fragment(self, ):
        ie = None

        # JMLformulas.g:189:10: ( '==>' ie= impliesNonBackwardExpression )
        # JMLformulas.g:189:10: '==>' ie= impliesNonBackwardExpression
        pass 
        self.match(self.input, 122, self.FOLLOW_122_in_synpred7_JMLformulas530)

        self._state.following.append(self.FOLLOW_impliesNonBackwardExpression_in_synpred7_JMLformulas534)
        ie = self.impliesNonBackwardExpression()

        self._state.following.pop()



    # $ANTLR end "synpred7_JMLformulas"



    # $ANTLR start "synpred30_JMLformulas"
    def synpred30_JMLformulas_fragment(self, ):
        id = None

        # JMLformulas.g:389:10: ( '.' id= IDENTIFIER )
        # JMLformulas.g:389:10: '.' id= IDENTIFIER
        pass 
        self.match(self.input, DOT, self.FOLLOW_DOT_in_synpred30_JMLformulas1907)

        id = self.match(self.input, IDENTIFIER, self.FOLLOW_IDENTIFIER_in_synpred30_JMLformulas1911)



    # $ANTLR end "synpred30_JMLformulas"



    # $ANTLR start "synpred31_JMLformulas"
    def synpred31_JMLformulas_fragment(self, ):
        sf = None

        # JMLformulas.g:396:10: (sf= identifierSuffix )
        # JMLformulas.g:396:10: sf= identifierSuffix
        pass 
        self._state.following.append(self.FOLLOW_identifierSuffix_in_synpred31_JMLformulas1949)
        sf = self.identifierSuffix()

        self._state.following.pop()



    # $ANTLR end "synpred31_JMLformulas"



    # $ANTLR start "synpred33_JMLformulas"
    def synpred33_JMLformulas_fragment(self, ):
        id = None

        # JMLformulas.g:409:10: ( '.' id= IDENTIFIER )
        # JMLformulas.g:409:10: '.' id= IDENTIFIER
        pass 
        self.match(self.input, DOT, self.FOLLOW_DOT_in_synpred33_JMLformulas2017)

        id = self.match(self.input, IDENTIFIER, self.FOLLOW_IDENTIFIER_in_synpred33_JMLformulas2021)



    # $ANTLR end "synpred33_JMLformulas"



    # $ANTLR start "synpred34_JMLformulas"
    def synpred34_JMLformulas_fragment(self, ):
        sf = None

        # JMLformulas.g:416:10: (sf= identifierSuffix )
        # JMLformulas.g:416:10: sf= identifierSuffix
        pass 
        self._state.following.append(self.FOLLOW_identifierSuffix_in_synpred34_JMLformulas2059)
        sf = self.identifierSuffix()

        self._state.following.pop()



    # $ANTLR end "synpred34_JMLformulas"



    # $ANTLR start "synpred52_JMLformulas"
    def synpred52_JMLformulas_fragment(self, ):
        ex = None

        # JMLformulas.g:472:10: ( '[' ex= expression ']' )
        # JMLformulas.g:472:10: '[' ex= expression ']'
        pass 
        self.match(self.input, LBRACKET, self.FOLLOW_LBRACKET_in_synpred52_JMLformulas2563)

        self._state.following.append(self.FOLLOW_expression_in_synpred52_JMLformulas2567)
        ex = self.expression()

        self._state.following.pop()

        self.match(self.input, RBRACKET, self.FOLLOW_RBRACKET_in_synpred52_JMLformulas2569)



    # $ANTLR end "synpred52_JMLformulas"



    # $ANTLR start "synpred74_JMLformulas"
    def synpred74_JMLformulas_fragment(self, ):
        # JMLformulas.g:630:11: ( ( predicate )? ';' )
        # JMLformulas.g:630:11: ( predicate )? ';'
        pass 
        # JMLformulas.g:630:11: ( predicate )?
        alt58 = 2
        LA58_0 = self.input.LA(1)

        if (LA58_0 == BANG or LA58_0 == BOOLEAN or LA58_0 == BYTE or (CHAR <= LA58_0 <= CHARLITERAL) or (DOUBLE <= LA58_0 <= DOUBLELITERAL) or LA58_0 == FALSE or (FLOAT <= LA58_0 <= FLOATLITERAL) or LA58_0 == IDENTIFIER or LA58_0 == INT or LA58_0 == INTLITERAL or (LONG <= LA58_0 <= LPAREN) or LA58_0 == NULL or LA58_0 == PLUS or LA58_0 == SHORT or (STRINGLITERAL <= LA58_0 <= SUB) or LA58_0 == SUPER or LA58_0 == THIS or LA58_0 == TILDE or LA58_0 == TRUE or LA58_0 == VOID or (126 <= LA58_0 <= 128)) :
            alt58 = 1
        if alt58 == 1:
            # JMLformulas.g:630:12: predicate
            pass 
            self._state.following.append(self.FOLLOW_predicate_in_synpred74_JMLformulas3480)
            self.predicate()

            self._state.following.pop()




        self.match(self.input, SEMI, self.FOLLOW_SEMI_in_synpred74_JMLformulas3487)



    # $ANTLR end "synpred74_JMLformulas"




    def synpred34_JMLformulas(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred34_JMLformulas_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred7_JMLformulas(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred7_JMLformulas_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred30_JMLformulas(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred30_JMLformulas_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred52_JMLformulas(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred52_JMLformulas_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred31_JMLformulas(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred31_JMLformulas_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred5_JMLformulas(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred5_JMLformulas_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred33_JMLformulas(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred33_JMLformulas_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred74_JMLformulas(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred74_JMLformulas_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success



 

    FOLLOW_expression_in_jml_formula85 = frozenset([91])
    FOLLOW_SEMI_in_jml_formula87 = frozenset([1])
    FOLLOW_conditionalExpression_in_expression126 = frozenset([1])
    FOLLOW_equivalenceExpression_in_conditionalExpression161 = frozenset([1, 86])
    FOLLOW_QUES_in_conditionalExpression182 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_expression_in_conditionalExpression186 = frozenset([24])
    FOLLOW_COLON_in_conditionalExpression188 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_conditionalExpression_in_conditionalExpression192 = frozenset([1])
    FOLLOW_impliesExpression_in_equivalenceExpression252 = frozenset([1, 118, 121])
    FOLLOW_equivalenceOp_in_equivalenceExpression273 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_impliesExpression_in_equivalenceExpression277 = frozenset([1])
    FOLLOW_121_in_equivalenceOp335 = frozenset([1])
    FOLLOW_118_in_equivalenceOp355 = frozenset([1])
    FOLLOW_conditionalOrExpression_in_impliesExpression390 = frozenset([1, 122])
    FOLLOW_122_in_impliesExpression411 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_impliesNonBackwardExpression_in_impliesExpression415 = frozenset([1, 122])
    FOLLOW_conditionalOrExpression_in_impliesExpression460 = frozenset([120])
    FOLLOW_120_in_impliesExpression471 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_conditionalOrExpression_in_impliesExpression473 = frozenset([1, 120])
    FOLLOW_conditionalOrExpression_in_impliesNonBackwardExpression509 = frozenset([1, 122])
    FOLLOW_122_in_impliesNonBackwardExpression530 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_impliesNonBackwardExpression_in_impliesNonBackwardExpression534 = frozenset([1, 122])
    FOLLOW_conditionalAndExpression_in_conditionalOrExpression594 = frozenset([1, 12])
    FOLLOW_BARBAR_in_conditionalOrExpression615 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_conditionalAndExpression_in_conditionalOrExpression619 = frozenset([1, 12])
    FOLLOW_inclusiveOrExpression_in_conditionalAndExpression679 = frozenset([1, 6])
    FOLLOW_AMPAMP_in_conditionalAndExpression700 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_inclusiveOrExpression_in_conditionalAndExpression704 = frozenset([1, 6])
    FOLLOW_exclusiveOrExpression_in_inclusiveOrExpression764 = frozenset([1, 11])
    FOLLOW_BAR_in_inclusiveOrExpression775 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_exclusiveOrExpression_in_inclusiveOrExpression777 = frozenset([1, 11])
    FOLLOW_andExpression_in_exclusiveOrExpression823 = frozenset([1, 17])
    FOLLOW_CARET_in_exclusiveOrExpression834 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_andExpression_in_exclusiveOrExpression836 = frozenset([1, 17])
    FOLLOW_equalityExpression_in_andExpression882 = frozenset([1, 5])
    FOLLOW_AMP_in_andExpression893 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_equalityExpression_in_andExpression895 = frozenset([1, 5])
    FOLLOW_instanceOfExpression_in_equalityExpression941 = frozenset([1, 10, 38])
    FOLLOW_EQEQ_in_equalityExpression983 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_BANGEQ_in_equalityExpression1004 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_instanceOfExpression_in_equalityExpression1037 = frozenset([1, 10, 38])
    FOLLOW_relationalExpression_in_instanceOfExpression1095 = frozenset([1])
    FOLLOW_shiftExpression_in_relationalExpression1130 = frozenset([1, 50, 70, 119, 123])
    FOLLOW_relationalOp_in_relationalExpression1153 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_shiftExpression_in_relationalExpression1157 = frozenset([1, 50, 70, 119, 123])
    FOLLOW_119_in_relationalOp1216 = frozenset([1])
    FOLLOW_123_in_relationalOp1230 = frozenset([1])
    FOLLOW_LT_in_relationalOp1243 = frozenset([1])
    FOLLOW_GT_in_relationalOp1258 = frozenset([1])
    FOLLOW_additiveExpression_in_shiftExpression1286 = frozenset([1])
    FOLLOW_multiplicativeExpression_in_additiveExpression1321 = frozenset([1, 80, 100])
    FOLLOW_PLUS_in_additiveExpression1363 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_SUB_in_additiveExpression1384 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_multiplicativeExpression_in_additiveExpression1417 = frozenset([1, 80, 100])
    FOLLOW_unaryExpression_in_multiplicativeExpression1477 = frozenset([1, 78, 93, 95])
    FOLLOW_STAR_in_multiplicativeExpression1519 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_SLASH_in_multiplicativeExpression1540 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_PERCENT_in_multiplicativeExpression1561 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_unaryExpression_in_multiplicativeExpression1594 = frozenset([1, 78, 93, 95])
    FOLLOW_PLUS_in_unaryExpression1654 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_unaryExpression_in_unaryExpression1659 = frozenset([1])
    FOLLOW_SUB_in_unaryExpression1679 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_unaryExpression_in_unaryExpression1683 = frozenset([1])
    FOLLOW_unaryExpressionNotPlusMinus_in_unaryExpression1703 = frozenset([1])
    FOLLOW_TILDE_in_unaryExpressionNotPlusMinus1736 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_unaryExpression_in_unaryExpressionNotPlusMinus1738 = frozenset([1])
    FOLLOW_BANG_in_unaryExpressionNotPlusMinus1758 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_unaryExpression_in_unaryExpressionNotPlusMinus1760 = frozenset([1])
    FOLLOW_primary_in_unaryExpressionNotPlusMinus1782 = frozenset([1, 30, 65])
    FOLLOW_selector_in_unaryExpressionNotPlusMinus1803 = frozenset([1, 30, 65])
    FOLLOW_parExpression_in_primary1863 = frozenset([1])
    FOLLOW_THIS_in_primary1886 = frozenset([1, 30, 65, 69])
    FOLLOW_DOT_in_primary1907 = frozenset([53])
    FOLLOW_IDENTIFIER_in_primary1911 = frozenset([1, 30, 65, 69])
    FOLLOW_identifierSuffix_in_primary1949 = frozenset([1])
    FOLLOW_IDENTIFIER_in_primary1996 = frozenset([1, 30, 65, 69])
    FOLLOW_DOT_in_primary2017 = frozenset([53])
    FOLLOW_IDENTIFIER_in_primary2021 = frozenset([1, 30, 65, 69])
    FOLLOW_identifierSuffix_in_primary2059 = frozenset([1])
    FOLLOW_SUPER_in_primary2104 = frozenset([30, 69])
    FOLLOW_superSuffix_in_primary2114 = frozenset([1])
    FOLLOW_literal_in_primary2124 = frozenset([1])
    FOLLOW_primitiveType_in_primary2144 = frozenset([30, 65])
    FOLLOW_LBRACKET_in_primary2155 = frozenset([88])
    FOLLOW_RBRACKET_in_primary2157 = frozenset([30, 65])
    FOLLOW_DOT_in_primary2178 = frozenset([23])
    FOLLOW_CLASS_in_primary2180 = frozenset([1])
    FOLLOW_VOID_in_primary2190 = frozenset([30])
    FOLLOW_DOT_in_primary2192 = frozenset([23])
    FOLLOW_CLASS_in_primary2194 = frozenset([1])
    FOLLOW_jmlPrimary_in_primary2204 = frozenset([1])
    FOLLOW_BOOLEAN_in_primitiveType2238 = frozenset([1])
    FOLLOW_CHAR_in_primitiveType2258 = frozenset([1])
    FOLLOW_BYTE_in_primitiveType2278 = frozenset([1])
    FOLLOW_SHORT_in_primitiveType2298 = frozenset([1])
    FOLLOW_INT_in_primitiveType2318 = frozenset([1])
    FOLLOW_LONG_in_primitiveType2338 = frozenset([1])
    FOLLOW_FLOAT_in_primitiveType2358 = frozenset([1])
    FOLLOW_DOUBLE_in_primitiveType2378 = frozenset([1])
    FOLLOW_LPAREN_in_parExpression2415 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_expression_in_parExpression2417 = frozenset([90])
    FOLLOW_RPAREN_in_parExpression2419 = frozenset([1])
    FOLLOW_arguments_in_superSuffix2450 = frozenset([1])
    FOLLOW_DOT_in_superSuffix2460 = frozenset([53])
    FOLLOW_IDENTIFIER_in_superSuffix2471 = frozenset([1, 69])
    FOLLOW_arguments_in_superSuffix2482 = frozenset([1])
    FOLLOW_LBRACKET_in_identifierSuffix2517 = frozenset([88])
    FOLLOW_RBRACKET_in_identifierSuffix2519 = frozenset([30, 65])
    FOLLOW_DOT_in_identifierSuffix2540 = frozenset([23])
    FOLLOW_CLASS_in_identifierSuffix2542 = frozenset([1])
    FOLLOW_LBRACKET_in_identifierSuffix2563 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_expression_in_identifierSuffix2567 = frozenset([88])
    FOLLOW_RBRACKET_in_identifierSuffix2569 = frozenset([1, 65])
    FOLLOW_arguments_in_identifierSuffix2614 = frozenset([1])
    FOLLOW_DOT_in_identifierSuffix2634 = frozenset([23])
    FOLLOW_CLASS_in_identifierSuffix2636 = frozenset([1])
    FOLLOW_DOT_in_identifierSuffix2646 = frozenset([107])
    FOLLOW_THIS_in_identifierSuffix2648 = frozenset([1])
    FOLLOW_DOT_in_identifierSuffix2658 = frozenset([103])
    FOLLOW_SUPER_in_identifierSuffix2660 = frozenset([69])
    FOLLOW_arguments_in_identifierSuffix2662 = frozenset([1])
    FOLLOW_DOT_in_selector2685 = frozenset([53])
    FOLLOW_IDENTIFIER_in_selector2689 = frozenset([1, 69])
    FOLLOW_arguments_in_selector2712 = frozenset([1])
    FOLLOW_LBRACKET_in_selector2757 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_expression_in_selector2759 = frozenset([88])
    FOLLOW_RBRACKET_in_selector2761 = frozenset([1])
    FOLLOW_classOrInterfaceType_in_createdName2794 = frozenset([1])
    FOLLOW_primitiveType_in_createdName2814 = frozenset([1])
    FOLLOW_IDENTIFIER_in_classOrInterfaceType2847 = frozenset([1])
    FOLLOW_LPAREN_in_arguments2890 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 90, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_expressionList_in_arguments2895 = frozenset([90])
    FOLLOW_RPAREN_in_arguments2922 = frozenset([1])
    FOLLOW_expression_in_expressionList2967 = frozenset([1, 25])
    FOLLOW_COMMA_in_expressionList2978 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_expression_in_expressionList2982 = frozenset([1, 25])
    FOLLOW_INTLITERAL_in_literal3040 = frozenset([1])
    FOLLOW_LONGLITERAL_in_literal3060 = frozenset([1])
    FOLLOW_FLOATLITERAL_in_literal3080 = frozenset([1])
    FOLLOW_DOUBLELITERAL_in_literal3100 = frozenset([1])
    FOLLOW_CHARLITERAL_in_literal3120 = frozenset([1])
    FOLLOW_STRINGLITERAL_in_literal3140 = frozenset([1])
    FOLLOW_TRUE_in_literal3160 = frozenset([1])
    FOLLOW_FALSE_in_literal3180 = frozenset([1])
    FOLLOW_NULL_in_literal3200 = frozenset([1])
    FOLLOW_resultExpression_in_jmlPrimary3234 = frozenset([1])
    FOLLOW_oldExpression_in_jmlPrimary3254 = frozenset([1])
    FOLLOW_specQuantifiedExpression_in_jmlPrimary3274 = frozenset([1])
    FOLLOW_128_in_resultExpression3307 = frozenset([1])
    FOLLOW_oldId_in_oldExpression3340 = frozenset([69])
    FOLLOW_LPAREN_in_oldExpression3342 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_specExpression_in_oldExpression3344 = frozenset([90])
    FOLLOW_RPAREN_in_oldExpression3346 = frozenset([1])
    FOLLOW_expression_in_specExpression3379 = frozenset([1])
    FOLLOW_LPAREN_in_specQuantifiedExpression3441 = frozenset([124, 125])
    FOLLOW_quantifier_in_specQuantifiedExpression3452 = frozenset([14, 16, 21, 31, 45, 53, 58, 67, 92])
    FOLLOW_quantifiedVarDecls_in_specQuantifiedExpression3454 = frozenset([91])
    FOLLOW_SEMI_in_specQuantifiedExpression3456 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 91, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_predicate_in_specQuantifiedExpression3480 = frozenset([91])
    FOLLOW_SEMI_in_specQuantifiedExpression3487 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_specExpression_in_specQuantifiedExpression3500 = frozenset([90])
    FOLLOW_RPAREN_in_specQuantifiedExpression3510 = frozenset([1])
    FOLLOW_125_in_quantifier3543 = frozenset([1])
    FOLLOW_124_in_quantifier3564 = frozenset([1])
    FOLLOW_normalParameterDecl_in_quantifiedVarDecls3599 = frozenset([1, 25])
    FOLLOW_COMMA_in_quantifiedVarDecls3620 = frozenset([14, 16, 21, 31, 45, 53, 58, 67, 92])
    FOLLOW_normalParameterDecl_in_quantifiedVarDecls3624 = frozenset([1, 25])
    FOLLOW_createdName_in_normalParameterDecl3684 = frozenset([53, 65])
    FOLLOW_LBRACKET_in_normalParameterDecl3706 = frozenset([88])
    FOLLOW_RBRACKET_in_normalParameterDecl3708 = frozenset([53, 65])
    FOLLOW_IDENTIFIER_in_normalParameterDecl3746 = frozenset([1, 25])
    FOLLOW_COMMA_in_normalParameterDecl3767 = frozenset([53])
    FOLLOW_IDENTIFIER_in_normalParameterDecl3771 = frozenset([1, 25])
    FOLLOW_specExpression_in_predicate3829 = frozenset([1])
    FOLLOW_conditionalOrExpression_in_synpred5_JMLformulas390 = frozenset([1, 122])
    FOLLOW_122_in_synpred5_JMLformulas411 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_impliesNonBackwardExpression_in_synpred5_JMLformulas415 = frozenset([1, 122])
    FOLLOW_122_in_synpred7_JMLformulas530 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_impliesNonBackwardExpression_in_synpred7_JMLformulas534 = frozenset([1])
    FOLLOW_DOT_in_synpred30_JMLformulas1907 = frozenset([53])
    FOLLOW_IDENTIFIER_in_synpred30_JMLformulas1911 = frozenset([1])
    FOLLOW_identifierSuffix_in_synpred31_JMLformulas1949 = frozenset([1])
    FOLLOW_DOT_in_synpred33_JMLformulas2017 = frozenset([53])
    FOLLOW_IDENTIFIER_in_synpred33_JMLformulas2021 = frozenset([1])
    FOLLOW_identifierSuffix_in_synpred34_JMLformulas2059 = frozenset([1])
    FOLLOW_LBRACKET_in_synpred52_JMLformulas2563 = frozenset([9, 14, 16, 21, 22, 31, 32, 42, 45, 46, 53, 58, 60, 67, 68, 69, 75, 80, 92, 99, 100, 103, 107, 110, 112, 114, 126, 127, 128])
    FOLLOW_expression_in_synpred52_JMLformulas2567 = frozenset([88])
    FOLLOW_RBRACKET_in_synpred52_JMLformulas2569 = frozenset([1])
    FOLLOW_predicate_in_synpred74_JMLformulas3480 = frozenset([91])
    FOLLOW_SEMI_in_synpred74_JMLformulas3487 = frozenset([1])



      
def main(argv, otherArg=None):
  pf = parseFile(argv[1])

def parseFile(filename):
  char_stream = ANTLRFileStream(filename)
  lexer = JMLformulasLexer(char_stream)
  tokens = CommonTokenStream(lexer)
  parser = JMLformulasParser(tokens);
 
  JML_fmla = None
  errors = False
  try:
        JML_fmla = parser.jml_formula()
  except RecognitionException:
    errors = True
  if errors:
    return None
  else:
    return JML_fmla

def parseString(str):
  if not str.endswith(';'):
     str = str + ';'
  char_stream = ANTLRStringStream(str)
  lexer = JMLformulasLexer(char_stream)
  tokens = CommonTokenStream(lexer)
  parser = JMLformulasParser(tokens);
 
  JML_fmla = None
  errors = False
  try:
        JML_fmla = parser.jml_formula()
  except RecognitionException:
    errors = True
  if errors:
    return None
  else:
    return JML_fmla


if __name__ == '__main__':
    main(sys.argv)
