
# This methods takes a java file and a mapping and generates a  new java file
# in which all mapped invariants are commented.
# This method takes three paths
# mapping is the file mapping vcc invariants to java invariants: vcc -> java
# java_file is the original java file
# new_file is the path to the file where the new version (with commented invariants) should be written
def delete_invariants(dictionary, path_java_file, path_new_file):
    
    #as long as we are not within a try block, copy each line from the old to the new java file
    #for try blocks, buffer the lines until we know whether they have to be commented
    #try blocks end when another try block starts, or when the pattern try .... Throwable t_instrument ... } is found
    #try blocks are commented if they contain an if statement which contains something from the map
    
    
    
    #open the files
    new_java_file = open(path_new_file, 'w')
    java_file = open(path_java_file, 'r')
    #set of invariants against which we have to check
    invariants = None
    # are we outside of a try block?
    print_directly = True
    # did we see  "t_instrument" in this try block?
    saw_t_instrument = False
    # did an if statement match in this try block?
    match = False
    #current buffer
    buffer = []
    for line in java_file:
        # do we enter a new loop_invariant() and have to look for other patterns?
        if("private static void" in line and not "internal$" in line):
            for loop_header,invariant_set in dictionary.items():
                if loop_header.loop_id in line:
                    if not invariants == None:
                        if invariants:
                            #invariants is not empty!
                            for inv in invariants:
                                print("Could not comment invariants: ", inv)
                    invariants = set(invariant_set)
        # enter new try block
        if "try" in line:
            for buffered in buffer:
                new_java_file.write(buffered)
            print_directly = False;
            buffer = []
        # outside try block
        if print_directly:
            new_java_file.write(line);
        #within try block
        else:
            buffer.append(line)
            #end of try block
            if saw_t_instrument and "}" in line:
                if match:
                    new_java_file.write("/*")
                for buffered in buffer:
                    new_java_file.write(buffered)
                if match:
                    new_java_file.write("*/")
                buffer = []
                print_directly = True
                saw_t_instrument = False
                match = False
            #just found t_instrument in this try block
            if not saw_t_instrument and  "Throwable t_instrument" in line:
                saw_t_instrument = True
            #if statement which might match some invariant
            if not print_directly and "if" in line and invariants != None:
                remove_invariant = None
                for invariant in invariants:
                    stripped_invariant = invariant[1].strip().replace(" ","")
                    stripped_line = line.replace(" ","")
                    if stripped_invariant in stripped_line:
                        match = True
                        remove_invariant = invariant
                        break
                if match:
                    invariants.remove(remove_invariant)
    #write everything still remaining in the buffer
    for buffered in buffer:
        new_java_file.write(buffered)          
    if not invariants == None:
        if invariants:
            #invariants is not empty!
            for inv in invariants:
                print("Could not comment invariants: ", inv)
                          
    java_file.close();
    new_java_file.close();
 
#example of how it could be used
#if __name__ == '__main__':
#    delete_invariants("/Users/may/phd/loopmate-python/new_feature/mapping.txt", "/Users/may/phd/loopmate-python/new_feature/ArrayMerge.java", "/Users/may/phd/loopmate-python/new_feature/ArrayMergeNew.java")