#!/usr/bin/env python
'''
Created on Oct 13, 2012

@author: galeotti
'''

from loopmate_escj import ensure_dir
import subprocess
import os

CWD = os.getcwd()

RESULTS_DIR = CWD + "/results"

PYTHON_CMD = "python3.2"
LOOPMATE_PY = CWD + "/scripts/loopmate_escj.py"
#=======================================================================
class LoopmateStats:
    abnormal_termination = 0
    normal_termination = 0
    stop_criteria_fixpoint = 0
    stop_criteria_verification = 0
    number_of_repetitions = 0

#=====================================================================================

def run_subprocess(command):
    proc = subprocess.Popen(command, shell=True, bufsize=0, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    stdout, stderr = proc.communicate()
    return stdout, stderr, proc.returncode

#=======================================================================


def run_loopmate_subprocess(case_study, work_dir, log_filename, err_filename):
     
    cmd = " ".join([PYTHON_CMD, LOOPMATE_PY, case_study, work_dir, "2>", err_filename, "|", "tee", log_filename])
    print("Executing " + cmd)
    stdout, stderr, returncode = run_subprocess(cmd)
    return stdout, stderr, returncode


#=======================================================================

if __name__ == '__main__':
    case_studies = list()

    case_studies.append("two_color_dutch_national_flag")
    case_studies.append("slow_copy")
    case_studies.append("division")
    case_studies.append("fisher_yates")
    case_studies.append("fill_sequence")
    case_studies.append("negate_array")
    case_studies.append("multiply")
    case_studies.append("equals_array")
    case_studies.append("gnome_sort")
    case_studies.append("is_sorted")
    case_studies.append("up_sort")
    case_studies.append("insertion_sort")
    case_studies.append("truncate_array")
    case_studies.append("find_min_value")
    case_studies.append("bubble_sort")
    case_studies.append("copy_array")
    case_studies.append("fill_array")
    case_studies.append("clear_array")
    case_studies.append("binary_search")
    case_studies.append("reverse_array")
    case_studies.append("linear_search")
    case_studies.append("quick_sort_partition")
    case_studies.append("find_max_index_subrange")
    case_studies.append("selection_sort")
    case_studies.append("copy_subrange")
    case_studies.append("concat_array")
    case_studies.append("merge_arrays")
    case_studies.append("gcd")

    REPETITIONS = 2
    
    # run experiments
    for case_study_run in range(REPETITIONS):
        for case_study in case_studies:
                
            work_dir = RESULTS_DIR + "/" + case_study + "_" + str(case_study_run)
            print("Executing case study " + case_study + " repetition " + str(case_study_run))
            ensure_dir(work_dir)
            log_filename = work_dir + "/" + 'loopmate-out.txt'
            err_filename = work_dir + "/" + 'loopmate-err.txt'
            stdout, stderr, returncode = run_loopmate_subprocess(case_study, work_dir, log_filename, err_filename)
