package java2.lang2;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

import org.ginpink.daikon.SnapshotIntValue;
import org.ginpink.daikon.SnapshotNonNullReference;
import org.ginpink.eval.InstanceConstructor;


public final class IntegerConstructor implements InstanceConstructor {

	private static final String INT_VALUE = "intValue";
	private static final String JAVA2_LANG2_INTEGER = "java2.lang2.Integer";

	@Override
	public Object createInstance(SnapshotNonNullReference ref) {
		if (!ref.getCanonicalClassName().equals(JAVA2_LANG2_INTEGER))
			throw new IllegalArgumentException();

		if (ref.getFieldValue(INT_VALUE) == null)
			throw new IllegalStateException();

		if (!(ref.getFieldValue(INT_VALUE) instanceof SnapshotIntValue))
			throw new IllegalArgumentException();

		SnapshotIntValue snap_int_value = (SnapshotIntValue) ref
				.getFieldValue(INT_VALUE);

		int intValue = snap_int_value.intValue();

		ClassLoader class_loader = ClassLoader.getSystemClassLoader();

		try {
			Class<?> clazz = class_loader.loadClass(JAVA2_LANG2_INTEGER);
			Constructor<?> constructor = clazz.getConstructor(int.class);
			Object concrete_value = constructor.newInstance(intValue);
			ref.setConcreteValue(concrete_value);
			return concrete_value;

		} catch (ClassNotFoundException e) {
			throw new RuntimeException("Could not load class for "
					+ JAVA2_LANG2_INTEGER);
		} catch (SecurityException e) {
			throw new RuntimeException("Expecting " + JAVA2_LANG2_INTEGER
					+ "  has a public constructor with argument int", e);

		} catch (NoSuchMethodException e) {
			throw new RuntimeException("Expecting " + JAVA2_LANG2_INTEGER
					+ " has a public constructor with argument int", e);
		} catch (java.lang.IllegalArgumentException e) {
			throw new RuntimeException(e);
		} catch (InstantiationException e) {
			throw new RuntimeException(e);
		} catch (IllegalAccessException e) {
			throw new RuntimeException(e);
		} catch (InvocationTargetException e) {
			throw new RuntimeException(e);
		}

	}

	@Override
	public String getClassName() {
		return JAVA2_LANG2_INTEGER;
	}

}
