package org.ginpink;

import org.ginpink.expr.JExpr;

public final class Invariant {

	private final JExpr java_expr;

	private final String java_string;

	private final String jml_string;

	public Invariant(JExpr java_format, String java_string, String jml_string) {
		this.java_expr = java_format;
		this.java_string = java_string;
		this.jml_string = jml_string;
	}

	public JExpr getJavaExpr() {
		return java_expr;
	}

	public String getJmlString() {
		return jml_string;
	}
	
	public String getJavaString() {
		return java_string;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((java_expr == null) ? 0 : java_expr.hashCode());
		result = prime * result
				+ ((java_string == null) ? 0 : java_string.hashCode());
		result = prime * result
				+ ((jml_string == null) ? 0 : jml_string.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Invariant other = (Invariant) obj;
		if (java_expr == null) {
			if (other.java_expr != null)
				return false;
		} else if (!java_expr.equals(other.java_expr))
			return false;
		if (java_string == null) {
			if (other.java_string != null)
				return false;
		} else if (!java_string.equals(other.java_string))
			return false;
		if (jml_string == null) {
			if (other.jml_string != null)
				return false;
		} else if (!jml_string.equals(other.jml_string))
			return false;
		return true;
	}
	
}
