package org.ginpink.daikon;

import daikon.FileIO;
import daikon.PptMap;
import daikon.PptTopLevel;
import daikon.ProglangType;
import daikon.ValueTuple;
import daikon.VarInfo;

public final class PrettyPrintingProcessor extends FileIO.Processor {

	@Override
	public void process_sample(PptMap all_ppts, PptTopLevel ppt, ValueTuple vt,
			Integer nonce) {
		System.out
				.println("=====================================================");
		System.out.println("ppt: " + ppt.name());
		
		for (int i = 0; i < ppt.var_infos.length; i++) {
			VarInfo varInfo = ppt.var_infos[i];
			Object value = vt.getValue(varInfo);

			ProglangType type = varInfo.type;
			if (varInfo.arr_dims != 0 || !varInfo.isArray()) {
				System.out.println("VarInfo=" + varInfo.name() + " Type="
						+ type.toString() + " Value=" + String.valueOf(value)
						+ " isArray()=" + type.isArray() + " isPrimitive()="
						+ type.isPrimitive() + " isHashCode()="
						+ type.isHashcode());
			}
		}

	}

}
