package org.ginpink.eval;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.SortedSet;
import java.util.TreeSet;

public final class JavaHeap {

	private LinkedList<String> nullValues = new LinkedList<String>();
	private HashMap<String, Object> objectValues = new HashMap<String, Object>();

	public void setInt(String parameterName, int intValue) {
		setObject(parameterName, intValue);
	}

	public void setLong(String parameterName, long longValue) {
		setObject(parameterName, longValue);
	}

	public int getInt(String parameterName) {
		return (Integer) objectValues.get(parameterName);
	}

	public void setArrayInt(String parameterName, int[] intArray) {
		objectValues.put(parameterName, intArray);
	}

	public void setArrayLong(String parameterName, long[] longArray) {
		objectValues.put(parameterName, longArray);
	}

	public int[] getArrayInt(String parameterName) {
		return (int[]) objectValues.get(parameterName);
	}

	public void setNull(String parameterName) {
		nullValues.add(parameterName);
	}

	public boolean isNull(String parameterName) {
		return nullValues.contains(parameterName);
	}

	public Object getObject(String parameterName) {
		return objectValues.get(parameterName);
	}

	public void setObject(String parameterName, Object value) {
		objectValues.put(parameterName, value);
	}

	public void setBoolean(String parameterName, boolean booleanValue) {
		setObject(parameterName, booleanValue);
	}

	public String toString() {
		StringBuffer buff = new StringBuffer();
		SortedSet<String> sortedSet = new TreeSet<String>();
		sortedSet.addAll(nullValues);
		sortedSet.addAll(objectValues.keySet());
		for (String key : sortedSet) {
			if (buff.length() > 0) {
				buff.append(",");
			}
			if (nullValues.contains(key)) {
				buff.append(key + "->" + "null");
			} else {
				Object value = objectValues.get(key);
				String valueStr;
				if (value instanceof int[]) {
					int[] intArray = (int[]) value;
					valueStr = java.util.Arrays.toString(intArray);
				} else if (value instanceof Object[]) {
					Object[] intArray = (Object[]) value;
					valueStr = java.util.Arrays.toString(intArray);
				} else {
					valueStr = String.valueOf(value);
				}
				buff.append(key + "->" + valueStr);
			}
		}
		return "[" + buff.toString() + "]";
	}
}
