package org.ginpink.expr;

public final class JArrayAccess extends JExpr {

	public JArrayAccess(JExpr arrayExpr, JExpr indexExpr) {
		super();
		this.arrayExpr = arrayExpr;
		this.indexExpr = indexExpr;
	}

	private final JExpr arrayExpr;
	private final JExpr indexExpr;

	@Override
	public <T> T accept(JExprVisitor<T> v) {
		return v.visit(this);
	}

	public JExpr getArrayExpr() {
		return arrayExpr;
	}

	public JExpr getIndexExpr() {
		return indexExpr;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((arrayExpr == null) ? 0 : arrayExpr.hashCode());
		result = prime * result
				+ ((indexExpr == null) ? 0 : indexExpr.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		JArrayAccess other = (JArrayAccess) obj;
		if (arrayExpr == null) {
			if (other.arrayExpr != null)
				return false;
		} else if (!arrayExpr.equals(other.arrayExpr))
			return false;
		if (indexExpr == null) {
			if (other.indexExpr != null)
				return false;
		} else if (!indexExpr.equals(other.indexExpr))
			return false;
		return true;
	}

}
