package org.ginpink.expr;

public final class JBooleanConstant extends JConstant {

	private final boolean booleanValue;
	
	public JBooleanConstant(boolean booleanValue) {
		super(true);
		this.booleanValue = booleanValue;
	}

	public boolean booleanValue() {
		return booleanValue;
	}

	@Override
	public <T> T accept(JExprVisitor<T> v) {
		return v.visit(this);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + (booleanValue ? 1231 : 1237);
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		JBooleanConstant other = (JBooleanConstant) obj;
		if (booleanValue != other.booleanValue)
			return false;
		return true;
	}
}
