package org.ginpink.expr;

public final class JConditionalExpr extends JExpr {

	public JConditionalExpr(JExpr predExpr, JExpr trueExpr, JExpr falseExpr) {
		super();
		this.predExpr = predExpr;
		this.trueExpr = trueExpr;
		this.falseExpr = falseExpr;
	}

	private final JExpr predExpr;
	private final JExpr trueExpr;
	private final JExpr falseExpr;

	@Override
	public <T> T accept(JExprVisitor<T> v) {
		return v.visit(this);
	}

	public JExpr getPredExpr() {
		return predExpr;
	}

	public JExpr getTrueExpr() {
		return trueExpr;
	}

	public JExpr getFalseExpr() {
		return falseExpr;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((falseExpr == null) ? 0 : falseExpr.hashCode());
		result = prime * result
				+ ((predExpr == null) ? 0 : predExpr.hashCode());
		result = prime * result
				+ ((trueExpr == null) ? 0 : trueExpr.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		JConditionalExpr other = (JConditionalExpr) obj;
		if (falseExpr == null) {
			if (other.falseExpr != null)
				return false;
		} else if (!falseExpr.equals(other.falseExpr))
			return false;
		if (predExpr == null) {
			if (other.predExpr != null)
				return false;
		} else if (!predExpr.equals(other.predExpr))
			return false;
		if (trueExpr == null) {
			if (other.trueExpr != null)
				return false;
		} else if (!trueExpr.equals(other.trueExpr))
			return false;
		return true;
	}

}
