package org.ginpink.expr;

public final class JDot extends JExpr {

	public JDot(JExpr left, JIdentifier right) {
		super();
		this.left = left;
		this.right = right;
	}

	private final JExpr left;
	private final JIdentifier right;

	@Override
	public <T> T accept(JExprVisitor<T> v) {
		return v.visit(this);
	}

	public JExpr getLeft() {
		return left;
	}

	public JIdentifier getRight() {
		return right;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((left == null) ? 0 : left.hashCode());
		result = prime * result + ((right == null) ? 0 : right.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		JDot other = (JDot) obj;
		if (left == null) {
			if (other.left != null)
				return false;
		} else if (!left.equals(other.left))
			return false;
		if (right == null) {
			if (other.right != null)
				return false;
		} else if (!right.equals(other.right))
			return false;
		return true;
	}

}
