package org.ginpink.expr;

public interface JExprVisitor<T> {

	// type checked

	T visit(JBinaryOperation e);

	T visit(JIntegerConstant e);

	T visit(JLongConstant e);

	T visit(JVar e);

	T visit(JInstanceMethodCall e);

	T visit(JUnaryOperation e);

	T visit(JBooleanConstant e);

	T visit(JStaticMethodCall e);

	T visit(JInstanceField e);

	T visit(JConditionalExpr e);

	T visit(JNullExpr jNullExpr);

	T visit(JArrayAccess e);

	// non-type checked

	T visit(JIdentifier e);

	T visit(JDot e);

	T visit(JMethodCall e);

	T visit(JClassName e);

	T visit(JStringLiteral e);

}
