package org.ginpink.expr;

public final class JInstanceField extends JExpr {

	public JInstanceField(JExpr receiver, String fieldName) {
		super();
		this.instanceExpr = receiver;
		this.fieldName = fieldName;
	}


	private final JExpr instanceExpr;
	private final String fieldName;
	
	
	@Override
	public <T> T accept(JExprVisitor<T> v) {
		return v.visit(this);
	}


	public JExpr getInstanceExpr() {
		return instanceExpr;
	}


	public String getFieldName() {
		return fieldName;
	}


	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((fieldName == null) ? 0 : fieldName.hashCode());
		result = prime * result
				+ ((instanceExpr == null) ? 0 : instanceExpr.hashCode());
		return result;
	}


	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		JInstanceField other = (JInstanceField) obj;
		if (fieldName == null) {
			if (other.fieldName != null)
				return false;
		} else if (!fieldName.equals(other.fieldName))
			return false;
		if (instanceExpr == null) {
			if (other.instanceExpr != null)
				return false;
		} else if (!instanceExpr.equals(other.instanceExpr))
			return false;
		return true;
	}

}
